/*
DisChoco: Distributed Constraint Reasoning Solver 
Copyright (C) 2007-2013 Redouane Ezzahir & Mohamed Wahbi 

DisChoco is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

DisChoco is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

To contact the authors: <http://dischoco.sourceforge.net/>
*/ 
package benchmark.meetingscheduling;

/**
 * 
 * @authors 
 * <a href="mailto:ezzahir@ensa-agadir.ac.ma?subject=DisChoco &cc=wahbi@lirmm.fr &cc=bessiere@lirmm.fr">
 * Redoaune Ezzahir</a> and 
 * <a href="mailto:wahbi@lirmm.fr?subject=DisChoco &cc=ezzahir@ensa-agadir.ac.ma &cc=bessiere@lirmm.fr">
 * Mohamed Wahbi</a>
 *
 */
public class Time implements Comparable<Object> {

	// SUNDAY, MONDAY, TUESDAY, WEDNESDAY, THURSDAY, FRIDAY, SATURDAY
	// private static final String MONDAY = "MONDAY";
	private int hour;
	private int day;

	public Time(int day, int hour) {
		this.hour = hour;
		this.day = day;
	}

	public int getDay() {
		return this.day;
	}

	public int getHour() {
		return this.hour;
	}

	public void setDay(int day) {
		this.day = day;
	}

	public void setHour(int hour) {
		this.hour = hour;
	}

	public int toInteger() {
		return this.day * 24 + this.hour;
	}

	public String toString() {
		return "(" + this.day + "," + this.hour + ")";
	}

	public String pretty() {
		String day = Time.getDay(this.day % 5);
		return day + ": " + this.hour + "h";
	}

	public static String getDay(int day) {
		switch (day % 7) { // SUNDAY, MONDAY, TUESDAY, WEDNESDAY, THURSDAY,
			// FRIDAY, SATURDAY
			case 0 :
				return "MONDAY   ";
			case 1 :
				return "TUESDAY  ";
			case 2 :
				return "WEDNESDAY";
			case 3 :
				return "THURSDAY ";
			case 4 :
				return "FRIDAY   ";
			case 5 :
				return "SATURDAY ";
			default :
				return "SUNDAY   ";
		}
	}

	// public static Time[] Week(int disponibility) {
	// int nbDays = 5;
	// int nbHours = 8;
	// Time[] week = new Time[nbDays*nbHours];
	// for(int d=0 ; d< nbDays ; d++){
	// for(int h=0 ; h<nbHours/2 ; h++){
	// int morning = h+nbHours;
	// int afternoon = h+nbHours+6;
	// week[d*nbHours+h] = new Time(d, morning);
	// week[d*nbHours+h+4] = new Time(d, afternoon);
	// }
	// }
	// return week;
	// }
	public static Time fromString(String meetingTime) {
		meetingTime = meetingTime.substring(meetingTime.indexOf("(") + 1, meetingTime.indexOf(")"));
		String[] meeting = meetingTime.split(",");
		int day = new Integer(meeting[0]);
		int hour = new Integer(meeting[1]);
		return new Time(day, hour);
	}

	public int compareTo(Object obj) {
		Time arg = (Time) obj;
		int day = arg.getDay();
		int hour = arg.getHour();
		if (this.day > day || (this.day == day && this.hour > hour)) {
			return 1;
		} else {
			if (this.day == day && this.hour == hour) {
				return 0;
			} else {
				return -1;
			}
		}
	}

}
