package gui;

import java.io.File;

import javax.swing.filechooser.FileFilter;

/**
 * 
 * @authors <a href="mailto:ezzahir@ensa-agadir.ac.ma?subject=DisChoco &cc=wahbi@lirmm.fr &cc=bessiere@lirmm.fr"> Redoaune Ezzahir</a> and <a
 *          href="mailto:wahbi@lirmm.fr?subject=DisChoco &cc=ezzahir@ensa-agadir.ac.ma &cc=bessiere@lirmm.fr"> Mohamed Wahbi</a>
 * 
 */
public class Filter extends FileFilter {
	String[] extensions;
	String description;

	public Filter(String[] extensions, String description) {
		this.extensions = extensions;
		this.description = description;
	}

	boolean contains(String ext) {
		for (String e : extensions)
			if (ext.equals(e)){
				return true;
			}
		return false;
	}

	public boolean accept(File f) {
		if (f.isDirectory()){
			return true;
		}
		String ext = null;
		String s = f.getName();
		int i = s.lastIndexOf('.');
		if (i > 0 && i < s.length() - 1)
			ext = s.substring(i + 1).toLowerCase();
		return ext != null && contains(ext);
	}

	public String getDescription() {
		return this.description;
	}

}
