/** 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version. 
 *  
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details. 
 *  
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA 
 * 
 * @version 2.0
 * DisChoco
 * JavaFileView.java
 */
package gui;

import static dischoco.DisChoco.ICONS_PATH;
import java.io.File;
import javax.swing.ImageIcon;
import javax.swing.filechooser.FileView;

/**
 * 
 * 
 * @authors <a href="mailto:ezzahir@ensa-agadir.ac.ma?subject=DisChoco &cc=wahbi@lirmm.fr &cc=bessiere@lirmm.fr"> Redoaune Ezzahir</a> and <a
 *          href="mailto:wahbi@lirmm.fr?subject=DisChoco &cc=ezzahir@ensa-agadir.ac.ma &cc=bessiere@lirmm.fr"> Mohamed Wahbi</a>
 * 
 */

public class JavaFileView extends FileView {
	public final static ImageIcon xmlIcon = new ImageIcon(ClassLoader.getSystemClassLoader().getResource(ICONS_PATH + "blog_post.png"));
	public final static ImageIcon csvIcon = new ImageIcon(ClassLoader.getSystemClassLoader().getResource(ICONS_PATH + "blog_post.png"));
	public final static ImageIcon bz2Icon = new ImageIcon(ClassLoader.getSystemClassLoader().getResource(ICONS_PATH + "archive.png"));
	public final static ImageIcon folderIcon = new ImageIcon(ClassLoader.getSystemClassLoader().getResource(ICONS_PATH + "folder.png"));
	public final static ImageIcon pdfIcon = new ImageIcon(ClassLoader.getSystemClassLoader().getResource(ICONS_PATH + "pdf.png"));
	public final static ImageIcon homeIcon = new ImageIcon(ClassLoader.getSystemClassLoader().getResource(ICONS_PATH + "home.png"));

	// public String getName(File file) {
	// String filename = file.getName();
	// if (filename.endsWith(".xml")) {
	// String name = filename + " : " + file.length();
	// return name;
	// }
	// return null;
	// }

	public String getTypeDescription(File file) {
		String typeDescription = null;
		String filename = file.getName().toLowerCase();
		if (file.isDirectory()) {
			typeDescription = "directory";
		} else if (filename.endsWith(".xml")) {
			typeDescription = "XML file";
		} else if (filename.endsWith(".pdf")) {
			typeDescription = "PDF file";
		} else if (filename.endsWith(".bz2")) {// compressed
			typeDescription = "Archive file";
		} else if (filename.endsWith(".csv")) {// compressed
			typeDescription = "Comma Separator Vector file"; // 
		} else if (filename.endsWith("jpeg") || filename.endsWith("jpg")) {
			typeDescription = "JPEG Image";
        } else if (filename.endsWith("gif")){
        	typeDescription = "GIF Image";
        } else if (filename.endsWith("tiff") || filename.endsWith("tif")) {
        	typeDescription = "TIFF Image";
        } else if (filename.endsWith("png")){
        	typeDescription = "PNG Image";
        }
		return typeDescription;
	}
    

	public ImageIcon getIcon(File file) {
		if (file.isDirectory()) { return folderIcon; }
		ImageIcon icon = null;
		String filename = file.getName().toLowerCase();
		if (filename.endsWith(".pdf")) {
			icon = pdfIcon;
		} else if (filename.endsWith(".xml")) {
			icon = xmlIcon;
		} else if (filename.endsWith(".bz2")) {
			icon = bz2Icon;
		} else if (filename.endsWith(".csv")) {
			icon = csvIcon;
		}
		return icon;
	}

	public static ImageIcon getIconOf(File file) {
		ImageIcon icon = folderIcon;
		if (file.isDirectory()) { 
			return icon;
		}
		String filename = file.getName().toLowerCase();
		if (filename.endsWith(".pdf")) {
			icon = pdfIcon;
		} else if (filename.endsWith(".xml")) {
			icon = xmlIcon;
		} else if (filename.endsWith(".bz2")) {
			icon = bz2Icon;
		} else if (filename.endsWith(".csv")) {
			icon = csvIcon;
		} else {
			icon = new ImageIcon(file.getAbsolutePath());
		}
		return icon;
	}

}
