/*
DisChoco: Distributed Constraint Reasoning Solver 
Copyright (C) 2007-2013 Redouane Ezzahir & Mohamed Wahbi 

DisChoco is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

DisChoco is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

To contact the authors: <http://dischoco.sourceforge.net/>
*/ 
package gui.debug;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableCellRenderer;


/**
 * @version dischoco 2.5.3<br/>
 * gui.debug.k.java
 * @author Mohamed Wahbi
 */

@SuppressWarnings("serial")
public class RelationRenderer extends DefaultTableCellRenderer {

	private int selectedRow = -1;
	
	public RelationRenderer() {
		super();
	}

	public RelationRenderer(int row) {
		this();
		this.setSelectedRow(row);
	}

	public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
		JTextField editor = new JTextField();
		if (value != null) {
			editor.setText(value.toString());
		}
		if(row == getSelectedRow()) {
			editor.setBackground(Color.cyan);
			Font currentFont = editor.getFont();
			editor.setFont(new Font(currentFont.getFamily(), Font.BOLD, currentFont.getSize()));
		} else {
			editor.setBackground(Color.white);
		}
		editor.setBorder(null);
		return editor;
	}

	/**
	 * @return the selectedRow
	 */
	public int getSelectedRow() {
		return selectedRow;
	}

	/**
	 * @param selectedRow the selectedRow to set
	 */
	public void setSelectedRow(int selectedRow) {
		this.selectedRow = selectedRow;
	}
}