package gui.graph.control;

import gui.graph.presentation.GraphComponent;
import gui.graph.presentation.GraphPresentation;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;


@SuppressWarnings("serial")
public class PopupMenuTool<T extends Comparable<? super T>> extends JPopupMenu {//implements PopupMenuListener {

	protected final GraphComponent<T> component;
	
	public PopupMenuTool(GraphComponent<T> component) {
		this.component = component;
		JMenuItem removeMenuItem = new JMenuItem("Remove Vertex");
		removeMenuItem.addActionListener(new RemoveVertexAction());
		add(removeMenuItem);
	}


	class RemoveVertexAction implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			GraphPresentation<T> graph = component.getGraphPresentation();
			graph.removeSelectedVertex();
			component.makeVisualChanges();
		}
		
	}
	
}
