package gui.tree.control;

import gui.tree.presentation.TreeComponent;
import gui.tree.presentation.TreePresentation;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;


@SuppressWarnings("serial")
public class PopupMenuTool<T extends Comparable<? super T>> extends JPopupMenu {//implements PopupMenuListener {

	protected final TreeComponent<T> component;
	
	public PopupMenuTool(TreeComponent<T> component) {
		this.component = component;
		JMenuItem removeMenuItem = new JMenuItem("Remove Vertex");
		removeMenuItem.addActionListener(new RemoveVertexAction());
		add(removeMenuItem);
	}


	class RemoveVertexAction implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			TreePresentation<T> tree = component.getTreePresentation();
			tree.removeSelectedVertex();
			component.makeVisualChanges();
		}
		
	}
	
}
