package kernel.constraints.integer;

public abstract class ConsistencyRelation implements Cloneable {

	protected boolean feasible;

	/**
	 * Checks whether the relation is defined with feasible tuples or infeasible one.
	 */
	public boolean isDefinedByFeasability() {
		return feasible;
	}

	/**
	 * Inverses the feasibility of the relation
	 */
	public void switchToOppositeRelation() {
		feasible = !feasible;
	}

	/**
	 * Return the opposite relation of itself
	 */
	public abstract ConsistencyRelation getOpposite();

	/**
	 * transpose the relation to checks (x,y) we use (y,x)
	 */
	public abstract void transpose();

}
