package kernel.constraints.integer;

import kernel.vars.integer.IntExternalVar;
import kernel.vars.integer.IntVariable;

public class SGreaterThanEqualXYC extends SIntBinConstraint {

	public SGreaterThanEqualXYC(IntVariable var0, IntExternalVar var1) {
		super(var0, var1);
	}

	public SGreaterThanEqualXYC(IntVariable var0, IntExternalVar var1, int cste) {
		super(var0, var1, cste);
	}

	/**
	 * Returns a string representation of this object
	 */
	public String toString() {
		return this.getReference() + ":[ " + this.v0 + this.type + this.v1 + " + " + cste + " ]";
	}

	@Override
	public boolean isConsistent(int val0, int val1) {
		this.incrementNumConstraintChecks(1);
		return val0 >= val1 + cste;
	}

	@Override
	public void propagate() {
		this.incrementNumConstraintChecks(1);
		if (v0.getInf() < v1.getInf() + cste)
			v0.updateInf(v1.getInf() + cste, index);
		if (v0.getSup() < v1.getSup() + cste)
			v1.updateSup(v0.getSup() - cste, index);
	}

	@Override
	public void awakeOnVar(IntVariable v) {
		this.incrementNumConstraintChecks(1);
		if (v1.equals(v) && v0.getInf() < v1.getInf() + cste)
			v0.updateInf(v1.getInf() + cste, index);
		if (v0.equals(v) && v0.getSup() < v1.getSup() + cste)
			v1.updateSup(v0.getSup() - cste, index);
	}

}
