package kernel.constraints.integer;

import kernel.Constraint;
import kernel.vars.integer.IntExternalVar;
import kernel.vars.integer.IntVariable;

public class SLessThanEqualXYC extends SIntBinConstraint {

	public SLessThanEqualXYC(IntVariable var0, IntExternalVar var1) {
		super(var0, var1);
		this.type = Constraint.leq;
	}

	public SLessThanEqualXYC(IntVariable var0, IntExternalVar var1, int cste) {
		super(var0, var1, cste);
		this.type = Constraint.leq;
	}

	/**
	 * Returns a string representation of this object
	 */
	public String toString() {
		return this.getReference() + ":[ " + this.v0 + this.type + this.v1 + " + " + cste + " ]";
	}

	@Override
	public boolean isConsistent(int val0, int val1) {
		this.incrementNumConstraintChecks(1);
		return val0 <= val1 + cste;
	}

	@Override
	public void propagate() {
		this.incrementNumConstraintChecks(1);
		if (v0.getInf() > v1.getInf() + cste)
			v1.updateInf(v0.getInf() - cste, index);
		if (v0.getSup() > v1.getSup() + cste)
			v0.updateSup(v1.getSup() + cste, index);
	}

	@Override
	public void awakeOnVar(IntVariable v) {
		if (v.equals(v0) && v0.getInf() > v1.getInf() + cste)
			v1.updateInf(v0.getInf() - cste, index);
		if (v.equals(v1) && v0.getSup() > v1.getSup() + cste)
			v0.updateSup(v1.getSup() + cste, index);
	}

}
