package kernel.constraints.integer;

import kernel.Constraint;
import kernel.vars.integer.IntExternalVar;
import kernel.vars.integer.IntVariable;

public class SNotEqualXYC extends SIntBinConstraint {

	public SNotEqualXYC(IntVariable var0, IntExternalVar var1) {
		super(var0, var1);
		this.type = Constraint.neq;
	}

	public SNotEqualXYC(IntVariable var0, IntExternalVar var1, int cste) {
		super(var0, var1, cste);
		this.type = Constraint.neq;
	}

	@Override
	public boolean isConsistent(int val1, int val2) {
		this.incrementNumConstraintChecks(1);
		return val1 != val2 + cste;
	}

	/**
	 * Returns a string representation of this object
	 */
	public String toString() {
		return this.getReference() + ":[ " + this.v0.toString() + " # " + this.v1.toString() + " + " + cste + " ]";
	}

	@Override
	public void propagate() {
		this.incrementNumConstraintChecks(1);
		// if (v0.getOriginalDomainSize() == 1) {
		// v1.delete(v0.getInf() - cste, this.index);
		// } else
		if (v0.getDomainSize() == 1) {
			v1.removeValue(v0.getInf() - cste, this.index);
		}
		// if (v1.getOriginalDomainSize() == 1) {
		// v0.delete(v1.getInf() + cste, this.index);
		// } else
		if (v1.getDomainSize() == 1) {
			v0.removeValue(v1.getInf() + cste, this.index);
		}
	}

	@Override
	public void awakeOnVar(IntVariable v) {
		this.incrementNumConstraintChecks(1);
		if (v0.equals(v) && v0.getDomainSize() == 1) {
			v1.removeValue(v0.getInf() - cste, this.index);
		}
		// if (v1.getOriginalDomainSize() == 1) {
		// v0.delete(v1.getInf() + cste, this.index);
		// } else
		if (v1.equals(v) && v1.getDomainSize() == 1) {
			v0.removeValue(v1.getInf() + cste, this.index);
		}
	}

}
