package kernel.constraints.integer.explain;

import kernel.Variable;
import kernel.constraints.integer.SUnaryIntConstraint;
import kernel.vars.integer.IntVariable;
import kernel.vars.integer.explain.ExplainedIntVar;

public class SEUnaryIntConstraint extends SUnaryIntConstraint implements Propagator {

	public SEUnaryIntConstraint(String Type, IntVariable var, int cste) {
		super(Type, var, cste);
	}
	
	@Override
	public void awakeOnVariableEvent(Variable v, int evtType) {
		if (!this.isSatisfied()) { throw new Error("SEUnaryIntConstraint not satisfied !"); }
	}

	@Override
	public void setUnPosted() {
		for (int i = 0 ; i < this.getNbExternalVars() ; i++)
			((ExplainedIntVar) this.getExternalVar(i)).removeExplanation(this.index);
		for (int i = 0 ; i < this.getNbInternalVars() ; i++)
			((ExplainedIntVar) this.getInternalVar(i)).removeExplanation(this.index);
		super.setUnPosted();
	}

	@Override
	public void awakeOnDecSup(ExplainedIntVar var) {}

	@Override
	public void awakeOnDesInst(ExplainedIntVar var) {}

	@Override
	public void awakeOnIncrInf(ExplainedIntVar var) {}

	@Override
	public void awakeOnInst(ExplainedIntVar var) {}

	@Override
	public void awakeOnRemovals(ExplainedIntVar var) {}

	@Override
	public void awakeOnRestores(ExplainedIntVar var) {}

}
