package kernel.events;

import kernel.AbstractAgent;

/**
 * An abstract class represents an event object that indicates event occurred on an agent;
 * 
 * @author Redouane EZZAHIR
 */

public abstract class AgentEvent {
	/**
	 * The agent on which the event is produced
	 */
	AbstractAgent agent;

	/**
	 * constructs an AgentEvent
	 * 
	 * @param agent
	 *            the agent on which the event is produced
	 */
	public AgentEvent(AbstractAgent agent) {
		this.agent = agent;
	}

	/**
	 * Get the agent on which the event is produced
	 */
	public AbstractAgent getAgent() {
		return agent;
	}
}
