package kernel.events;

import java.util.EventListener;

/**
 * An interface that all agent event listener class must implement.
 */
public interface AgentEventListener extends EventListener {
	/**
	 * To handle an agent event This method must be implemented when extending this class
	 * 
	 * @see simple.dcsp.abtfamily.IdleEvent
	 * @see kernel.events.AgentEventListener
	 */
	public void handleAgentEvent(AgentEvent agentEvent);

}
