package kernel.events;

import kernel.AbstractAgent;

/**
 * A class models the event "Agent has finished"
 * 
 * @author Redouane Ezzahir
 * 
 */
public class AgentFinishedEvent extends AgentEvent {

	/**
	 * A field storing the state of the termination
	 */
	String terminateState = "";

	/**
	 * Constructs an event of termination
	 * 
	 * @param agent
	 *            the agent on which the termination is detected
	 * @param endState
	 *            the state of termination
	 */
	public AgentFinishedEvent(AbstractAgent agent, String endState) {
		super(agent);
		this.terminateState = endState;
	}

}
