package kernel.events;

import kernel.Constraint;
import kernel.Variable;

public interface PropagationEngine {
	/**
	 * Returns the next queue from which an event should be propagated.
	 */
	public EventQueue<? extends DisChocoEvent<?>> getNextActiveEventQueue();

	/**
	 * Generic method to post events.
	 */
	public void postEvent(Variable v, int idx, int basicEvt);

	public VariableEventQueue getVarEventQueue();

	public boolean postConstAwake(Constraint constraint, boolean init);

	public void registerEvent(ConstraintEvent event);

	/**
	 * Removes all pending events (used when interrupting a propagation because a contradiction has been raised)
	 */
	public void flushEvents();

	public void propagate();

}
