/*******************************************************************

 ********************************************************************/

package kernel.events;

import java.util.EventListener;
import java.util.HashSet;

import kernel.VarIdentifier;
import kernel.Variable;

/**
 * ** An interface that all variable event listener class must implement.
 * 
 * @author Redouane Ezzahir
 * 
 */
public interface VariableEventListener extends EventListener {

	/**
	 * <i>Propagation:</i> Runs a pre-processing on the domain revision and propagates the constraint for the very first time until local consistency
	 * is reached.
	 */
	public void propagate();

	public ConstraintEvent getEvent();

	public void awakeOnVariableEvent(Variable v, int evtType);

	public void addVarEventSource(VarIdentifier varId);

	public void removeVarEventSource(VarIdentifier varId);

	public HashSet<VarIdentifier> getVarEventSources();

}
