package kernel.order;

import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import kernel.VarIdentifier;
import util.HashList;

/**
 * A class to construct the Lexicographic order
 * 
 * @author Redouane EZZAHIR
 * 
 */
public class LexicographicAO extends CentralizedAO implements ChainOrder {

	public LexicographicAO() {
		super();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see order.CentralizedAgentOrdering#buildAgentsOrder()
	 */
	public HashList<VarIdentifier> buildAgentsOrder() {
		HashList<VarIdentifier> order = new HashList<VarIdentifier>(this.agentsComplexity.keySet());
		Collections.sort(order, new Comparator<VarIdentifier>(){
			@Override
			public int compare(VarIdentifier varId0, VarIdentifier varId1) {
				return varId0.compareTo(varId1);
			}
		});
		return order;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see order.CentralizedAgentOrdering#buildAgentsOrder()
	 */
	public static HashList<VarIdentifier> buildAgentsOrder(HashMap<VarIdentifier, AgentComplexity> agentsComplexity) {
		HashList<VarIdentifier> order = new HashList<VarIdentifier>(agentsComplexity.keySet());
		Collections.sort(order, new Comparator<VarIdentifier>(){
			@Override
			public int compare(VarIdentifier varId0, VarIdentifier varId1) {
				return varId0.compareTo(varId1);
			}
		});
		return order;
	}

}
