package kernel.order;

import java.util.HashMap;
import java.util.List;
import java.util.Random;
import kernel.VarIdentifier;
import util.HashList;

/**
 * A class for random ordering
 * 
 * @author Redouane EZZAHIR
 * 
 */
public class RandomAO extends CentralizedAO implements ChainOrder {

	Random rand = new Random();

	/*
	 * (non-Javadoc)
	 * @see order.CentralizedAgentOrdering#buildAgentsOrder()
	 */
	public HashList<VarIdentifier> buildAgentsOrder() {
		rand.setSeed(System.currentTimeMillis());
		HashList<VarIdentifier> order = new HashList<VarIdentifier>();
		List<VarIdentifier> list = new HashList<VarIdentifier>(this.agentsComplexity.keySet());
		while(!list.isEmpty()) {
			int choosen = this.rand.nextInt(list.size());
			order.add(list.remove(choosen));
		}
		return order;
	}

	/**
	 * @param complexities
	 * @return
	 */
	public static HashList<VarIdentifier> buildpriorityTree(HashMap<VarIdentifier, AgentComplexity> complexities) {
		Random rand = new Random();
		rand.setSeed(System.currentTimeMillis());
		HashList<VarIdentifier> order = new HashList<VarIdentifier>();
		List<VarIdentifier> list = new HashList<VarIdentifier>(complexities.keySet());
		while(!list.isEmpty()) {
			int choosen = rand.nextInt(list.size());
			order.add(list.remove(choosen));
		}
		return order;
	}
}
