package kernel.vars.integer.explain;

import java.util.Collection;
import java.util.Iterator;
import kernel.vars.integer.IntDomain;
import util.IntArray;

public interface ExplainedIntDomain extends IntDomain {

	public final static int DOM = 1;
	public final static int INF = 2;
	public final static int SUP = 3;

	/**
	 * Removes the given explanation from the explanation set of the given value
	 * 
	 * @return <i><b>true</b></i> if the value passed in parameters was restored to the domain and <i><b>false</b></i> otherwise
	 */
	public boolean removeExplanation(int value, int expl);

	/**
	 * Removes an explanation index from the list of explanation.
	 */
	public boolean removeExplanation(int expl);

	public void addExplanation(int val, int expl);

	/**
	 * Returns the set of explanations stored for the given value
	 */
	public Collection<Explanation> getExplanation(int value);

	public Collection<Explanation> getExplanations(IntArray vals);

	public Collection<Explanation> getDomExplanations();

	public Collection<Explanation> getInfExplanations();

	public Collection<Explanation> getSupExplanations();

	public boolean remove(int val, int expl);

	public boolean updateInf(int inf, int expl);

	public boolean updateSup(int sup, int expl);

	public ExplainedIntDomain cloneOriginalDomain();

	public Iterator<Integer> getRepairIterator();

	public void releaseRepairDomain();
}
