package kernel.vars.integer.explain;

import java.util.Collection;

import kernel.vars.integer.IntVar;
import util.IntArray;

public interface ExplainedIntVar extends IntVar {

	public ExplainedIntDomain getDomain();

	public Collection<Explanation> getExplanation(int val);

	public Collection<Explanation> getExplanations(IntArray vals);

	public Collection<Explanation> getDomExplanations();

	public Collection<Explanation> getInfExplanations();

	public Collection<Explanation> getSupExplanations();

	/**
	 * 
	 * @param value
	 *            value to remove
	 * @param idx
	 *            index of propagated constraint
	 * @param expl
	 *            index of the cause/explanation
	 * @return
	 */
	public boolean removeValue(int value, int idx, int expl);

	public boolean updateInf(int x, int idx, int expl);

	public boolean updateSup(int x, int idx, int expl);

	public boolean removeInterval(int min, int max, int index, int expl);

	public boolean restrictDomainTo(int val, int index, int expl);

	public boolean removeValue(int value, int idx, Collection<Explanation> expl);

	public boolean updateInf(int x, int idx, Collection<Explanation> expl);

	public boolean updateSup(int x, int idx, Collection<Explanation> expl);

	public boolean removeInterval(int min, int max, int index, Collection<Explanation> expl);

	public boolean restrictDomainTo(int val, int index, Collection<Explanation> expl);

	public boolean removeExplanation(int index);

	public boolean removeExplanation(int value, int index);

	public boolean removeExplanationForInterval(int min, int max, int index);

	public int makeConstraintNogood(int val, Collection<Explanation> expl);

	public int makeConstraintNogood(IntArray vals, Collection<Explanation> expl);

	// public void removeValue(int value, int index, Explanation explanation);
}
