package kernel.vars.integer.explain;

import java.util.BitSet;

public class Explanation implements Cloneable {

	protected BitSet basicExp = null;

	public Explanation() {}

	public boolean equals(Object e) {
		if (e == null)
			return false;
		return this.basicExp.equals(((Explanation) e).basicExp);
	}

	public void add(int idx) {
		if (idx <= -1)
			throw new IndexOutOfBoundsException("Index of explanation can't be negative value!");
		if (basicExp == null)
			basicExp = new BitSet();
		this.basicExp.set(idx);
	}

	public boolean delete(int idx) {
		if (this.basicExp != null) {
			this.basicExp.clear(idx);
			if (this.basicExp.cardinality() == 0)
				this.basicExp = null;
		}
		return this.isEmpty();
	}

	public boolean contains(int idx) {
		if (idx > -1)
			return this.basicExp.get(idx);
		return false;
	}

	public boolean isEmpty() {
		return basicExp == null;
	}

	// public Explanation clone() {
	// Explanation e = new Explanation();
	// e.basicExp = new BitSet();
	// if (this.basicExp != null)
	// e.basicExp.or(this.basicExp);
	// return e;
	// }

	public int hashCode() {
		return this.basicExp.hashCode();
	}

	public String toString() {
		return "<" + this.basicExp + ">";
	}

	public BitSet getBitSet() {
		return this.basicExp;
	}
}
