package realisticuse;

import java.rmi.Naming;
import java.rmi.RemoteException;

import saci.Agent;
import saci.Config;
import saci.Message;
import saci.MessageHandler;
import saci.launcher.Launcher;
import kernel.com.CommunicationInterface;

public abstract class SaciComm extends Agent implements CommunicationInterface {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2632483150244768172L;

	final String myName;

	final String myDiscription = "?";

	final String socName = "DisChoco";

	protected Config config = new Config();

	Launcher launcher;

	public SaciComm(String name) {
		super();
		this.myName = name;
		config.set("society.name", socName);
	}

	public void initAg(String[] args) {
		addMsgHandlers();
	}

	public abstract void addMsgHandlers();

	protected void start() {
		System.out.println("strarting " + myName + " ...");
		connectLauncher();
		try {
			// if(this.getSociety()==null)
			enterSoc(myName, socName);
			System.out.println(this.getName() + ": I am entered to societie " + socName);
			initAg(null);
			run();

		} catch (Exception e) {
			e.printStackTrace();
			System.err.println("Error=" + e);
		}
	}

	protected boolean connectLauncher() {
		String URLServ = null;
		try {
			String host = config.get("master_host");
			if (host == null) {
				host = "localhost";
			}
			URLServ = "//" + host + "/Launcher";
			System.out.print("Trying to connect the launcher at " + URLServ + "...");
			launcher = (Launcher) Naming.lookup(URLServ);
			System.out.println(" ok.");

			return true;
		} catch (Exception e) {
			System.err.println("Error connecting launcher at " + URLServ + "\n" + e);
			return false;
		}
	}

	public Message createMessage(String msgId) {
		return new Message("(tell :ontology :content " + msgId + ")");
	}

	/**
	 * for compressed
	 */
	public Message createCompressedMsg(String msgId) {
		return new Message("(tell :ontology :content " + msgId + ")", true);
	}

	public void addMessageHandler(String msgId, MessageHandler handler) {
		// add a message handler to receive msgId messages
		try {
			mbox.addMessageHandler(msgId, null, null, "", handler);
		} catch (Exception e) {
			System.err.println("Error registering message handler:" + e);
		}
	}

	public void sendSaciMsg(saci.Message m) {
		try {
			// m.put("sender", myName);
			mbox.sendMsg(m);
		} catch (Exception e) {
			System.err.println("Error sending message " + m);
		}
	}

	public void broadcast(Message m) {
		try {
			// m.put("sender", myName);
			mbox.broadcast(m);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	@Override
	public void sendMessage(kernel.com.Message msg) {
		System.out.println("send message   " + msg);
		this.sendSaciMsg(MsgConverter.convert(msg));
	}

}
