package simple.dcop.synchbb;

import java.util.ArrayList;
import java.util.Collection;
import simulation.parser.PVariable;
import kernel.AbstractAgent;
import kernel.AbstractMaster;
import kernel.order.LexicographicAO;

public class SBBMaster extends AbstractMaster {

	public SBBMaster() {
		this.setCentralizedAO(new LexicographicAO());
	}

	@Override
	public AbstractAgent makeAgent(int id, String name, String description) {
		return new SBBAgent(id, name, description);
	}
	
	/* (non-Javadoc)
	 * @see kernel.AbstractMaster#makeAgent(simulation.parser.PVariable)
	 */
	@Override
	public AbstractAgent makeAgent(PVariable variable) {
		return new SBBAgent(variable);
	}

	/* (non-Javadoc)
	 * @see kernel.AbstractMaster#getTypesOfMessages()
	 */
	@Override
	public Collection<String> getTypesOfMessages() {
		Collection<String> ans = new ArrayList<String>();
		ans.add(SBBAgent.CPA);
		ans.add(SBBAgent.BACKTRACK);
		return ans;
	}

}
