package simple.dcsp.abtfamily.abt;

import java.util.ArrayList;
import java.util.Collection;
import kernel.AbstractAgent;
import kernel.AbstractMaster;
import kernel.order.LexicographicAO;
import simulation.parser.PVariable;
import util.Commands;

public class ABTMaster extends AbstractMaster {

	public ABTMaster() {
		this.setCentralizedAO(new LexicographicAO());
		this.addObserver(new TerminationDetector());
	}

	public AbstractAgent makeAgent(int agId, String name, String desc) {
		return new ABTAgent(agId, name, desc);
	}

	/* (non-Javadoc)
	 * @see kernel.AbstractMaster#makeAgent(simulation.parser.PVariable)
	 */
	@Override
	public AbstractAgent makeAgent(PVariable variable) {
		return new ABTAgent(variable);
	}

	/* (non-Javadoc)
	 * @see kernel.AbstractMaster#getTypesOfMessages()
	 */
	@Override
	public Collection<String> getTypesOfMessages() {
		Collection<String> ans = new ArrayList<String>();
		ans.add(Commands.OK);
		ans.add(Commands.NOGOOD);
		ans.add(Commands.ADDLINK);
		return ans;
	}

//	/* (non-Javadoc)
//	 * @see kernel.AbstractMaster#getAuxiliaryStatistics()
//	 */
//	@Override
//	protected List<String> getAuxiliaryStatistics() {
//		List<String> auxiliaryStatistics = new ArrayList<String>();
//		auxiliaryStatistics.add(Commands.nbObsoleteNogood);
//		auxiliaryStatistics.add(Commands.nbAssignments);
//		auxiliaryStatistics.add(Commands.ObsoleteOk);
//		auxiliaryStatistics.add(Commands.MSGsSIZE);
//		auxiliaryStatistics.add(Commands.MaxMSGsSIZE);
//		return auxiliaryStatistics;
//	}

}
