package simple.dcsp.abtfamily.abtdac;

import java.util.Iterator;
import kernel.AbstractAgent;
import kernel.Constraint;
import kernel.ConstraintsHandler;
import kernel.ExternalVar;
import kernel.Variable;
import kernel.events.VariableEvent;
import kernel.vars.integer.IntVar;

public class ABTdacConstraintHandler extends ConstraintsHandler {

	public ABTdacConstraintHandler(AbstractAgent agent) {
		super(agent);
	}

	// =================================================================================
	@Override
	public void processConstraint(Constraint c, Variable v, int evtType) {
		if (v instanceof ExternalVar) {
			c.awakeOnVariableEvent(v, evtType);
		} else {
			if (evtType == VariableEvent.REMOVE_VAL) { // ABT_DAC
				Iterator<Integer> it = ((IntVar) v).getDomain().getDeltaIterator();
				while (it.hasNext()) {
					// removedVals.add(it.next());
					int val = it.next();
					((ABTdacAgent) this.myAgent).sendConditionalDeldMsg(val);
				}
			} else if (evtType == VariableEvent.RESTORE_VAL)
				c.awakeOnVariableEvent(v, evtType);
		}

	}
	// =================================================================================

}
