package simple.dcsp.abtfamily.abtdo;

import kernel.StopException;
import kernel.VarIdentifier;
import kernel.com.Message;
import kernel.com.MessageHandler;
import simple.SimpleAgent;
import simple.dcsp.Nogood;
import util.Commands;
import util.Instantiation;

/**
 * for each value we store just one Nogood following this heuristic: when comparing two nogoods, select the one with the highest possible lowest
 * variable involved (Nogood Selector HPLV)
 */

public class NogoodMsgHandler extends MessageHandler {

	public NogoodMsgHandler(ABTDOAgent agent) {
		super(agent, Commands.NOGOOD);
	}

	/**
	 * 
	 */
	public void processMessage(Message msg) throws StopException {
		VarIdentifier senderId = msg.getSenderId();
		Instantiation ng = ((Instantiation) msg.get(Commands.NOGOOD)).clone(this.myAgent.agentOrder);
		VarIdentifier generator = (VarIdentifier) msg.get(Commands.Generator);
		int myValue = ((SimpleAgent) this.myAgent).var.getValue();
		VarIdentifier last = this.myAgent.agentOrder.getLowerAgent(ng.getVarIds());
		if (this.myAgent.getVarIdentifier().equals(last)) {
			Nogood nogood = new Nogood(ng);
			if (this.isCoherent(nogood)) {
				if (((ABTDOAgent) this.myAgent).iNogoodTriggered()) {
					((ABTDOAgent) this.myAgent).ChangeOrderNG(generator);
				}
				((ABTDOAgent) this.myAgent).CheckAddLink(nogood);
				((ABTDOAgent) this.myAgent).makeNoGoodConstraint(nogood);
				((ABTDOAgent) this.myAgent).CheckAgentView();
			} else {// re-send OK message
				this.myAgent.auxiliaryStatistics.get(Commands.nbObsoleteNogood).value++;
				if (nogood.getRhsValue() == myValue && generator.equals(senderId)) {
					((ABTDOAgent) this.myAgent).okMsgH.sendOkMessage(msg.getSenderId());
				}
			}
		} else {
			this.myAgent.auxiliaryStatistics.get(ABTDOAgent.nbIncompatibleNogood).value++;
			this.sendNogood(ng, generator, last);
			if (generator.equals(senderId)) {
				((ABTDOAgent) this.myAgent).okMsgH.sendOkMessage(msg.getSenderId());
			}
		}
	}

	/**
	 * @param ng
	 */
	public void sendNogood(Instantiation ng, VarIdentifier generator, VarIdentifier target) {
		Message msg = this.createMessage();
		msg.addContents(Commands.NOGOOD, ng.clone());
		msg.addContents(Commands.Generator, generator);
		msg.setReceiverId(target);
		((ABTDOAgent) this.myAgent).storeStatisticsFor(msg);
		this.myAgent.sendMessage(msg);
	}

	/**
	 * @param nogood
	 */
	public boolean isCoherent(Nogood nogood) {
		int myValue = ((ABTDOAgent) this.myAgent).var.getValue();
		return this.myAgent.agentView.compatibleWith(nogood.getLhs()) && nogood.getRhsValue() == myValue;
	}

}
