package simple.dcsp.abtfamily.abtdoretroz;

import kernel.AbstractAgent;
import kernel.StopException;
import kernel.VarIdentifier;
import kernel.com.Message;
import kernel.com.MessageHandler;
import kernel.vars.integer.explain.ExplainedIntVar;
import simple.SingleExplainedVarAgent;
import util.Commands;
import util.VarAssignment;

public class AddLinkMsgHandler extends MessageHandler {

	public AddLinkMsgHandler(AbstractAgent agent) {
		super(agent, Commands.ADDLINK);
	}

	/**
	 * @param msg
	 */
	public void processMessage(Message msg) throws StopException {
		VarIdentifier senderId = msg.getSenderId();
		VarAssignment ass = (VarAssignment) msg.get(Commands.OK);
		this.myAgent.communicator.addNeighbor(ass.getVarIdentifier());
		this.myAgent.agentView.add(this.myAgent.makeExternalVar(ass));
		ExplainedIntVar v = ((SingleExplainedVarAgent) this.myAgent).getMyVar();
		VarAssignment myAss = (VarAssignment) msg.get(Commands.LINK);
		if (!myAss.equals(v.getVarAssignment())) {/* re-send OK message */
			((ZABTDORetroAgent) this.myAgent).okMsgH.sendOkMessage(senderId);
		}
	}

	/**
	 * 
	 * @param ass
	 */
	public void sendAddLink(VarAssignment ass) {
		Message msg = this.createMessage();
		VarAssignment myAssignment = ((ZABTDORetroAgent) this.myAgent).var.getVarAssignment();
		msg.addContents(Commands.LINK, ass);
		msg.addContents(Commands.OK, myAssignment);
		msg.setReceiverId(ass.getVarIdentifier());
		this.myAgent.sendMessage(msg);
	}

}
