/*************************************************************************

 **************************************************************************/

package simple.dcsp.abtfamily.abtdoretroz;

import kernel.StopException;
import kernel.VarIdentifier;
import kernel.com.Message;
import kernel.com.MessageHandler;
import util.Commands;
import util.HashList;
import util.VarAssignment;

public class OkMsgHandler extends MessageHandler {

	public OkMsgHandler(ZABTDORetroAgent agent) {
		super(agent, Commands.OK);
	}

	/**
	 * @param msg
	 */
	public void processMessage(Message msg) throws StopException {
		VarAssignment senderAss = (VarAssignment) msg.get(Commands.OK);
		int domainSize = (Integer) msg.get(Commands.DomainSize);
		CurrentOrder currentOrder = (CurrentOrder) msg.get(Commands.ORDER);
		((ZABTDORetroAgent) this.myAgent).setCurrentOrder(currentOrder);
		((ZABTDORetroAgent) this.myAgent).setDomainSize(senderAss.getVarIdentifier(), domainSize);
		if (this.myAgent.agentView.compareTimeCounter(senderAss) >= 0) {
			this.myAgent.agentView.priorityMerge(senderAss);
			((ZABTDORetroAgent) this.myAgent).CheckAgentView();
		} else {
			this.myAgent.auxiliaryStatistics.get(Commands.ObsoleteOk).value++;
		}
	}

	/**
	 * 
	 */
	public void sendOkMessages() {
		HashList<VarIdentifier> neighbors = this.myAgent.communicator.getNeighbors();
		for (VarIdentifier neig : neighbors) {
			this.sendOkMessage(neig);
		}
		((ZABTDORetroAgent) this.myAgent).IChangedMyOrder = false;
	}

	/**
	 * 
	 */
	public void sendOkMessage(VarIdentifier receiverId) {
		int dom = ((ZABTDORetroAgent) this.myAgent).getMyVar().getDomainSize();
		VarAssignment myAssignment = ((ZABTDORetroAgent) this.myAgent).var.getVarAssignment();
		CurrentOrder currentOrder  = ((ZABTDORetroAgent) this.myAgent).getCurrentOrder();
		Message msg = createMessage();
		msg.addContents(Commands.DomainSize, dom);
		msg.addContents(Commands.OK, myAssignment);
		msg.addContents(Commands.ORDER, currentOrder);
		msg.setReceiverId(receiverId);
		((ZABTDORetroAgent) this.myAgent).storeStatisticsFor(msg);
		this.myAgent.sendMessage(msg);
	}

}
