/*************************************************************************

 **************************************************************************/
package simple.dcsp.abtfamily.abtdoretroz;

import kernel.AbstractMaster;
import kernel.StopException;
import kernel.VarIdentifier;
import kernel.com.Message;
import kernel.com.MessageHandler;
import kernel.vars.integer.explain.ExplainedIntVariable;
import util.Commands;
import util.HashList;

public class OrderMsgHandler extends MessageHandler {

	public OrderMsgHandler(ZABTDORetroAgent agent) {
		super(agent, Commands.ORDER);
	}

	/**
	 * @param msg
	 */
	public void processMessage(Message msg) throws StopException {
		int domainSize = (Integer) msg.get(Commands.DomainSize);
		CurrentOrder currentOrder = (CurrentOrder) msg.get(Commands.ORDER);
		VarIdentifier senderId = (VarIdentifier) msg.get(Commands.ID);
		if (((ZABTDORetroAgent) this.myAgent).setCurrentOrder(currentOrder)) {
			((ZABTDORetroAgent) this.myAgent).setDomainSize(senderId, domainSize);
			((ZABTDORetroAgent) this.myAgent).CheckAgentView();
		}
	}

	public void sendOrderMessages() {
		HashList<VarIdentifier> lowerAgents = this.myAgent.agentOrder.getLowerAgents();
		lowerAgents.removeAll(this.myAgent.communicator.getLowerNeighbors());
		for (VarIdentifier lower : lowerAgents) {
			this.sendOrderMessage(lower);
		}
		this.sendOrderMessage(AbstractMaster.MasterVarId);
	}
	
	public void sendOrderMessage(VarIdentifier receiver) {
		ExplainedIntVariable myVar = ((ZABTDORetroAgent) this.myAgent).getMyVar();
		int dom = myVar.getDomainSize();
		CurrentOrder currentOrder = ((ZABTDORetroAgent) this.myAgent).getCurrentOrder();
		Message msg = createMessage();
		msg.addContents(Commands.DomainSize, dom);
		msg.addContents(Commands.ORDER, currentOrder);
		msg.addContents(Commands.ID, myVar.getVarIdentifier());
		msg.setReceiverId(receiver);
		((ZABTDORetroAgent) this.myAgent).storeStatisticsFor(msg);
		this.myAgent.sendMessage(msg);
	}
}
