package simple.dcsp.abtfamily.abthyb;

import kernel.AbstractAgent;
import kernel.StopException;
import kernel.VarIdentifier;
import kernel.com.Message;
import simple.dcsp.Nogood;
import simple.dcsp.abtfamily.abt.ABTAgent;
import util.Commands;
import util.VarAssignment;

public class ABTHybAgent extends ABTAgent {
	
	private Nogood lastNogood ;
	private boolean wait = false;

	public ABTHybAgent(int agentId, String agName, String description) {
		super(agentId, agName, description);
		this.okMsgH = new HybOkMessageHandler(this);
		this.ngdMsgH = new HybNogoodsHandler(this);
	}

	/**
	 * @throws StopException
	 */
	@Override
	public void backtrack() throws StopException {
		this.resolveContradiction();
	}
	
	/**
	 * 
	 */
	@Override
	public void resolveContradiction() throws StopException {
		Nogood nogood = this.solveMyNogoods();
		if (nogood.isEmpty()) { throw new StopException(Commands.FAILURE); }
		this.lastNogood = nogood.clone();
		this.wait = true;
		this.agentView.clear(nogood.getRhs());
		this.ngdMsgH.sendNogood(nogood);
	}

	@Override
	public boolean isIdle() {
		if (!this.var.isInstantiated())
			return false;
		return this.agentView.getContextsOfHigherAgents().size() == this.communicator.getHigherNeighbors().size();

	}

	public class HybNogoodsHandler extends NogoodsHandler {

		public HybNogoodsHandler(AbstractAgent agent) {
			super(agent);
		}

		/**
		 * 
		 */
		@Override
		public void processMessage(Message msg) throws StopException {
			if(!((ABTHybAgent) this.myAgent).wait){
				super.processMessage(msg);
			}
		}

	}
	
	public class HybOkMessageHandler extends OkMessageHandler {

		public HybOkMessageHandler(AbstractAgent agent) {
			super(agent);
		}

		/**
		 * @param msg
		 */
		public void processMessage(Message msg) throws StopException {
			VarAssignment senderAss = (VarAssignment) msg.get(Commands.OK);
			int cmp = agentView.compareTimeCounter(senderAss);
			if (cmp >= 0) {
				agentView.priorityMerge(senderAss);
				if(wait){
					VarIdentifier sender = msg.getSenderId();
					Nogood ng = lastNogood.clone();
					if(sender.equals(ng.getRhsVarIdentifier()) || (ng.getLhs().contains(senderAss.getVarIdentifier()) && cmp > 0)){
						wait = false;
					}
				}
				if(!wait){
					checkAgentView();
				}
			} else {
				this.myAgent.auxiliaryStatistics.get(Commands.ObsoleteOk).value++;
			}
		}

	}
}
