package simple.dcsp.afcfamily.afc.domdeg;

import java.util.HashMap;
import kernel.AbstractAgent;
import kernel.VarIdentifier;
import kernel.com.Message;
import kernel.order.AgentComplexity;
import kernel.order.LexicographicAO;
import simple.dcsp.afcfamily.afc.AFCMaster;
import util.Commands;
import util.HashList;

public class AFCDomDegMaster extends AFCMaster {

	public static final int MinDom = 0;
	public static final int Dom_Static_Deg = 1;
	public static final int Dom_Dyn_Deg = 2;

	public AFCDomDegMaster() {
		super(true);
		this.setCentralizedAO(new LexicographicAO());
	}

	@Override
	public AbstractAgent makeAgent(int agId, String name, String description) {
		return new AFCDomDegAgent(agId, name, description, Dom_Dyn_Deg);
	}

	public void broadcast(Message msg, VarIdentifier agentId) {
		if (msg.getType().equals(Commands.AO)) {
			HashMap<VarIdentifier, AgentComplexity> ac = this.centralizedAO.getAgentsComplexity();
			HashList<VarIdentifier> agentsOrder = null;
			try {
				agentsOrder = HashList.fromString((String) msg.get(Commands.ORDER), VarIdentifier.class);
			} catch (Exception e) {
				e.printStackTrace();
			}
			for (VarIdentifier id : agentsOrder) {
				msg.addContents(id + "", new Integer(ac.get(id).getMaxDomain()));
			}
		}
		super.broadcast(msg, agentId);
	}

}
