package simple.dcsp.afcfamily.afc.estimDom;

import java.util.HashMap;
import kernel.AbstractAgent;
import kernel.VarIdentifier;
import kernel.com.Message;
import kernel.order.AgentComplexity;
import simple.dcsp.afcfamily.afc.AFCMaster;
import util.Commands;
import util.HashList;

public class AFCEstimatedMaster extends AFCMaster {

	private short type = MinDom;
	public static final short MinDom = 1;
	public static final short DomDeg = 2;

	public AFCEstimatedMaster(short type) {
		super(true);
		this.type = type;
	}

	@Override
	public AbstractAgent makeAgent(int agId, String name, String description) {
		return new AFCEstimatedAgent(agId, name, description, this.type);
	}

	public void broadcast(Message msg, VarIdentifier agentId) {
		if (msg.getType().equals(Commands.AO)) {
			HashMap<VarIdentifier, AgentComplexity> ac = this.centralizedAO.getAgentsComplexity();
			HashList<VarIdentifier> ao = null;
			try {
				ao = HashList.fromString((String)msg.get(Commands.ORDER), VarIdentifier.class);
			} catch (Exception e) {
				e.printStackTrace();
			}
			for (VarIdentifier varId : ao) {
				msg.addContents(varId + "", new Integer(ac.get(varId).getMaxDomain()));
			}
		}
		super.broadcast(msg, agentId);
	}

}
