package simple.dcsp.afcfamily.afc_dbj;

import java.util.ArrayList;
import java.util.Collection;

import kernel.AbstractAgent;
import kernel.AbstractMaster;
import kernel.order.LexicographicAO;
import simulation.parser.PVariable;
import util.Commands;

public class AFCDBJMaster extends AbstractMaster {

	public AFCDBJMaster() {
		this.setCentralizedAO(new LexicographicAO());
	}

	@Override
	public AbstractAgent makeAgent(int agId, String name, String description) {
		return new AFCDBJAgent(agId, name, description);
	}


	/* (non-Javadoc)
	 * @see kernel.AbstractMaster#makeAgent(simulation.parser.PVariable)
	 */
	@Override
	public AbstractAgent makeAgent(PVariable variable) {
		return new AFCDBJAgent(variable);
	}
	
	/* (non-Javadoc)
	 * @see kernel.AbstractMaster#getTypesOfMessages()
	 */
	@Override
	public Collection<String> getTypesOfMessages() {
		Collection<String> ans = new ArrayList<String>();
		ans.add(AFCDBJAgent.CPA);
		ans.add(AFCDBJAgent.BACKTRACK);
		ans.add(AFCDBJAgent.FC);
		ans.add(AFCDBJAgent.NOT_OK);
		ans.add(Commands.TERMINATION_DETECTION);
		return ans;
	}

}
