package simple.dcsp.afcfamily.afcng.afctree;

import java.util.ArrayList;
import java.util.Collection;

import kernel.AbstractAgent;
import kernel.order.TreeAO;
import simple.dcsp.afcfamily.afcng.AFCngAgent;
import simple.dcsp.afcfamily.afcng.AFCngMaster;
import util.Commands;

public class AFCTreeMaster extends AFCngMaster {

	public AFCTreeMaster() {
		super();
		this.setCentralizedAO(new TreeAO());
		((TreeAO) this.centralizedAO).orderSwitch = TreeAO.DFSCHAIN;
	}

	@Override
	public AbstractAgent makeAgent(int agentId, String agentName, String description) {
		return new AFCTreeAgent(agentId, agentName, description);
	}
	/* (non-Javadoc)
	 * @see kernel.AbstractMaster#getTypesOfMessages()
	 */
	@Override
	public Collection<String> getTypesOfMessages() {
		Collection<String> ans = new ArrayList<String>();
		ans.add(AFCngAgent.CPA);
		ans.add(AFCngAgent.NOGOOD);
		ans.add(Commands.TERMINATION_DETECTION);
		return ans;
	}

}
