package simple.dcsp.afcfamily.afcng.approximateDom;

import java.util.HashMap;
import kernel.AbstractAgent;
import kernel.VarIdentifier;
import kernel.com.Message;
import kernel.order.AgentComplexity;
import simple.dcsp.afcfamily.afcng.AFCngMaster;
import util.Commands;
import util.HashList;

public class AFCngApproximateMinDomMaster extends AFCngMaster {

	private short type = MinDom;
	public static final short MinDom = 1;
	public static final short MinDomDeg = 2;

	public AFCngApproximateMinDomMaster(short type) {
		this.type = type;
//		this.setCentralizedAO(new LexicographicAO());
	}

	@Override
	public AbstractAgent makeAgent(int agId, String name, String description) {
		return new AFCngApproximateMinDomAgent(agId, name, description, this.type);
	}

	public void broadcast(Message msg, VarIdentifier agentId) {
		if (msg.getType().equals(Commands.AO)) {
			HashMap<VarIdentifier, AgentComplexity> ac = this.centralizedAO.getAgentsComplexity();
			HashList<VarIdentifier> order = null;
			try {
				order = HashList.fromString((String) msg.get(Commands.ORDER), VarIdentifier.class);
			} catch (Exception e) {
				e.printStackTrace();
			}
			for (VarIdentifier varId : order){
				msg.addContents(varId + "", new Integer(ac.get(varId).getMaxDomain()));
			}
		}
		super.broadcast(msg, agentId);
	}

}
