package simple.dcsp.afcfamily.afcng.triggerednogood;

import kernel.StopException;
import kernel.VarIdentifier;
import simple.dcsp.Nogood;
import simple.dcsp.afcfamily.afcng.DynamicAFCngAgent;
import simple.dcsp.afcfamily.afcng.TimeStamp;
import util.Commands;
import util.Instantiation;

public class AFCngTriggeredNogoodAgent extends DynamicAFCngAgent {

	protected VarIdentifier nogoodGenerator = null;

//	public static final int DEG = 1;
//	public static final int FUTUR_DEG = 2;
//	public static final int PAST_DEG = 3;
//	protected int heuristic = DEG; // static or dynamic heuristic

	public AFCngTriggeredNogoodAgent(int agentId, String agName, String description) {
		super(agentId, agName, description);
	}

	// ========================================================================
	@Override
	public VarIdentifier getNextAgent() {
		if (this.nogoodGenerator != null && this.agentOrder.isLower(this.nogoodGenerator)){
			return this.nogoodGenerator;
		}
		return super.getNextAgent();
	}

	// ==========================================================================
//	@Override
	public void processNogood(Nogood nogood, TimeStamp timeStamp, Instantiation cpa, VarIdentifier generator) throws StopException {
		int cmp = this.timeStamp.compareTimeStamp(timeStamp);
		if (cmp > 0) {
			this.updateOrdering(cpa, timeStamp);
		}
		if (cmp >= 0) {
			if(this.agentViewConsistent && this.isCoherent(nogood)){
				this.nogoodGenerator = generator;
				this.makeNoGoodConstraint(nogood);
				this.assignCPA();
			} else{
				this.auxiliaryStatistics.get(Commands.nbObsoleteNogood).value++;
			}
		}
	}
	/**
	 * 
	 */
	@Override
	public void sendCPA(Instantiation cpa) throws StopException {
		super.sendCPA(cpa);
		this.nogoodGenerator = null;
	}

}