package simple.dcsp.afcfamily.ddbj;

import java.util.ArrayList;
import java.util.Collection;
import simulation.parser.PVariable;

import kernel.AbstractAgent;
import kernel.AbstractMaster;
import kernel.order.LexicographicAO;

public class DDBJMaster extends AbstractMaster {

	public DDBJMaster() {
		this.setCentralizedAO(new LexicographicAO());
	}

	@Override
	public AbstractAgent makeAgent(int agId, String name, String description) {
		return new DDBJAgent(agId, name, description);
	}

	/* (non-Javadoc)
	 * @see kernel.AbstractMaster#makeAgent(simulation.parser.PVariable)
	 */
	@Override
	public AbstractAgent makeAgent(PVariable variable) {
		return new DDBJAgent(variable);
	}

	/* (non-Javadoc)
	 * @see kernel.AbstractMaster#getTypesOfMessages()
	 */
	@Override
	public Collection<String> getTypesOfMessages() {
		Collection<String> ans = new ArrayList<String>();
		ans.add(DDBJAgent.CPA);
		ans.add(DDBJAgent.BACKTRACK);
		ans.add(DDBJAgent.FC);
		ans.add(DDBJAgent.NOT_OK);
		ans.add(DDBJAgent.PC);
		return ans;
	}

}
