package simple.dcsp.afcfamily.ddbj;

import java.util.Iterator;
import java.util.TreeMap;
import kernel.vars.integer.IntValSelector;
import simple.SimpleAgent;

public class MinConflictValSelector implements IntValSelector {

	SimpleAgent myAgent;
	TreeMap<Integer, Integer> counters ;

	public MinConflictValSelector(SimpleAgent agent) {
		this.myAgent = agent;
		this.counters = new TreeMap<Integer, Integer>();
	}

	public int getNextValue() {
		Iterator<Integer> it = this.myAgent.var.getDomain().iterator();
		int value = Integer.MAX_VALUE;
		if(it.hasNext()) 
			value = it.next();
		while(it.hasNext()){
			int val = it.next();
			if(this.counters.get(val) < this.counters.get(value) ){
				value = val;
			}
		}
//		System.out.println(this.counters+" : "+this.myAgent.var.getDomain());
//		System.out.println(value);
		return value;
	}

	public boolean hasNextValue() {
		return (this.myAgent.var.getDomainSize() > 0);
	}

	/**
	 * @param value
	 */
	public void increment(int value) {
		if(this.counters.get(value)==null){
			this.counters.put(value, 0);
		}
		int counter = this.counters.get(value);
		this.counters.put(value, counter+1); 
	}

	/**
	 * 
	 */
	public void initialize() {
		for(int value : this.myAgent.var.getDomain()){
			this.counters.put(value, 0);
		}
	}

}
