package simple.dcsp.agile.exp;

import kernel.AbstractAgent;
import kernel.StopException;
import kernel.VarIdentifier;
import kernel.com.Message;
import kernel.com.MessageHandler;
import util.Commands;
import util.Instantiation;
import util.VarAssignment;

public class AddLinkMsgHandler extends MessageHandler {

	public AddLinkMsgHandler(AbstractAgent agent) {
		super(agent, Commands.ADDLINK);
	}

	/**
	 * @param msg
	 */
	public void processMessage(Message msg) throws StopException {
		VarAssignment senderAss = (VarAssignment) msg.get(Commands.OK);
		VarIdentifier senderId = senderAss.getVarIdentifier();
		this.myAgent.communicator.addNeighbor(senderId);
		VarAssignment myAss = (VarAssignment) msg.get(AgileAgent.LINK);
		if (myAss.getValue() != ((AgileAgent) this.myAgent).getMyVar().getValue()) {
			/* re-send OK message */
			Instantiation lhs = ((AgileAgent) this.myAgent).getExplanationLhs();
			int rhs = ((AgileAgent) this.myAgent).getExplanationRhs();
			((AgileAgent) this.myAgent).okMsgH.sendOkMessage(senderId, lhs, rhs);
		}
	}

	/**
	 * 
	 * @param ass
	 */
	public void sendAddLink(VarAssignment ass) {
		Message msg = this.createMessage();
		VarAssignment myAssignment = ((AgileAgent) this.myAgent).var.getVarAssignment();
		msg.addContents(AgileAgent.LINK, ass);
		msg.addContents(Commands.OK, myAssignment);
		msg.setReceiverId(ass.getVarIdentifier());
		((AgileAgent)this.myAgent).storeStatisticsFor(msg);
		this.myAgent.sendMessage(msg);
	}

}
