/*************************************************************************

 **************************************************************************/

package simple.dcsp.agile.exp;

import kernel.StopException;
import kernel.VarIdentifier;
import kernel.com.Message;
import kernel.com.MessageHandler;
import util.Commands;
import util.HashList;
import util.Instantiation;
import util.Tools;
import util.VarAssignment;

public class OkMsgHandler extends MessageHandler {

	public OkMsgHandler(AgileAgent agent) {
		super(agent, Commands.OK);
	}

	/**
	 * @param msg
	 */
	public void processMessage(Message msg) throws StopException {
		VarAssignment ass = (VarAssignment) msg.get(Commands.OK);
		HashList<VarIdentifier> order = HashList.fromString((String) msg.get(Commands.ORDER), VarIdentifier.class);
		Double[] TV = Tools.arrayFromString((String) msg.get(AgileAgent.TV), Double.class);
		((AgileAgent) this.myAgent).checkOrder(order, TV);
		Instantiation lhs = (Instantiation) msg.get(Commands.LHS);
		int rhs = (Integer) msg.get(Commands.RHS);
		VarIdentifier senderId = msg.getSenderId();
		((AgileAgent) this.myAgent).updateAgentView(lhs, ass);
		((AgileAgent) this.myAgent).setExplanation(senderId, lhs, rhs);
		((AgileAgent) this.myAgent).CheckAgentView();
	}

	/**
	 * 
	 */
	public void sendOkMessages() {
		Instantiation lhs = ((AgileAgent) this.myAgent).getExplanationLhs();
		int rhs = ((AgileAgent) this.myAgent).getExplanationRhs();
		HashList<VarIdentifier> receivers = null;
		if (((AgileAgent) this.myAgent).onlyToNeighbors) {
			receivers = this.myAgent.communicator.getLowerNeighbors();
		} else {
			receivers = this.myAgent.agentOrder.getLowerAgents();
		}
		for (VarIdentifier lower : receivers) {
			this.sendOkMessage(lower, lhs, rhs);
		}
		((AgileAgent) this.myAgent).IchangeMyOrder = false;
	}

	/**
	 * 
	 * @param neig
	 * @param myExp
	 */
	public void sendOkMessage(VarIdentifier neig, Instantiation lhs, int rhs) {
		HashList<VarIdentifier> myOrder = this.myAgent.getOrder();
		String myTV = Tools.arrayToString(((AgileAgent) this.myAgent).myTV);
		Message msg = this.createMessage();
		msg.addContents(Commands.OK, ((AgileAgent) this.myAgent).var.getVarAssignment());
		msg.addContents(Commands.LHS, lhs);
		msg.addContents(Commands.RHS, rhs);
		msg.addContents(Commands.ORDER, myOrder.toString());
		msg.addContents(AgileAgent.TV, myTV);
		msg.setReceiverId(neig);
		((AgileAgent) this.myAgent).storeStatisticsFor(msg);
		this.myAgent.sendMessage(msg);
	}

}
