package simple.dcsp.agile.exp;

import kernel.AbstractAgent;
import kernel.StopException;
import kernel.VarIdentifier;
import kernel.com.Message;
import kernel.com.MessageHandler;
import util.Commands;
import util.HashList;
import util.Tools;

public class OrderMsgHandler extends MessageHandler {

	public OrderMsgHandler(AbstractAgent agent) {
		super(agent, Commands.ORDER);
	}

	@Override
	public void processMessage(Message msg) throws StopException {
		HashList<VarIdentifier> order = HashList.fromString("" + msg.get(Commands.ORDER), VarIdentifier.class);
		Double[] TV = Tools.arrayFromString((String) msg.get(AgileAgent.TV), Double.class);
		int weight = (Integer) msg.get(Commands.WEIGHT);
		VarIdentifier senderId = msg.getSenderId();
		((AgileAgent) this.myAgent).setWeights(senderId, weight);
		((AgileAgent) this.myAgent).checkOrder(order, TV);
		((AgileAgent) this.myAgent).CheckAgentView();
	}

	/**
	 * 
	 * @param agId
	 */
	public void broadcastOrder(VarIdentifier agId) {
		HashList<VarIdentifier> order = this.myAgent.getOrder();
		String TV = Tools.arrayToString(((AgileAgent) this.myAgent).myTV);
		Message msg = createMessage();
		msg.addContents(Commands.ORDER, order.toString());
		msg.addContents(AgileAgent.TV, TV);
		msg.addContents(Commands.WEIGHT, ((AgileAgent) this.myAgent).getMyWeight());
		order.remove(agId);
		order.remove(this.myAgent.getVarIdentifier());
		for (VarIdentifier neig : order) {
			msg.setReceiverId(neig);
			((AgileAgent)this.myAgent).storeStatisticsFor(msg);
			this.myAgent.sendMessage(msg);
		}
	}
}
