package simple.dcsp.dba;

import java.util.Iterator;
import java.util.Vector;

import kernel.AbstractAgent;
import kernel.Constraint;
import kernel.ConstraintsHandler;
import kernel.Variable;
import simple.dcsp.SimpleConstraint;

public class DBAConstraintHandler extends ConstraintsHandler {

	protected Vector<Constraint> violations;

	public DBAConstraintHandler(AbstractAgent agent) {
		super(agent);
		this.violations = new Vector<Constraint>();
	}

	public int computeEval(int value) {
		int eval = 0;
		if (((DBAagent) this.myAgent).var.getValue() == value) {
			for (Constraint exC : this.violations) {
				eval += exC.getWeight();
			}
			return eval;
		}
		Iterator<Constraint> it = this.getConstraintsIterator();
		while (it.hasNext()) {
			SimpleConstraint exC = (SimpleConstraint) it.next();
			if (!exC.isConsistent(value)) {
				eval += exC.getWeight();
			}
		}

		return eval;
	}

	public void increaseWeightsOfConstraintViolations() {
		for (Constraint exC : this.violations) {
			exC.setWeight(exC.getWeight() + 1);
		}
	}

	@Override
	public void processConstraint(Constraint c, Variable v, int evtType) {
		if (!c.isSatisfied()) {
			this.violations.add(c);
		}
	}

}
