package simple.dcsp.dba;

import kernel.AbstractAgent;
import kernel.StopException;
import kernel.VarIdentifier;
import kernel.com.Message;
import util.Commands;

public class ImproveMsgHandler extends kernel.com.MessageHandler {

	public ImproveMsgHandler(AbstractAgent agent) {
		super(agent, Commands.IMPROVE);
	}

	@Override
	public void processMessage(Message msg) throws StopException {
		int improve = Integer.parseInt((String) msg.get("IMPROV"));
		int eval = Integer.parseInt((String) msg.get("EVAL"));
		int terminateCounter = Integer.parseInt((String) msg.get("TERM-COUNTER"));
		VarIdentifier senderId = msg.getSenderId();
		((DBAagent) this.myAgent).processImprove(improve, eval, terminateCounter, senderId);

	}

	public void sendImproveMessages() {
		Message msg = this.createMessage();
		msg.addContents("IMPROV", ((DBAagent) this.myAgent).myImprove + "");
		msg.addContents("EVAL", ((DBAagent) this.myAgent).currentEval + "");
		msg.addContents("TERM-COUNTER", ((DBAagent) this.myAgent).myTerminationCounter + "");
		this.myAgent.broadcastMessageToNeighbors(msg);
	}

}
