package simple.dcsp.sbt;

import java.util.ArrayList;
import java.util.Collection;

import kernel.AbstractAgent;
import kernel.AbstractMaster;
import kernel.order.LexicographicAO;
import simulation.parser.PVariable;
import util.Commands;

public class SBTMaster extends AbstractMaster {

	public SBTMaster() {
		this.setCentralizedAO(new LexicographicAO());
	}

	@Override
	public AbstractAgent makeAgent(int agentId, String agentName, String description) {
		return new SBTAgent(agentId, agentName, description);
	}

	/* (non-Javadoc)
	 * @see kernel.AbstractMaster#makeAgent(simulation.parser.PVariable)
	 */
	@Override
	public AbstractAgent makeAgent(PVariable variable) {
		return new SBTAgent(variable);
	}

	/* (non-Javadoc)
	 * @see kernel.AbstractMaster#getTypesOfMessages()
	 */
	@Override
	public Collection<String> getTypesOfMessages() {
		Collection<String> ans = new ArrayList<String>();
		ans.add(Commands.CPA);
		ans.add(Commands.BACKTRACK);
		ans.add(Commands.TERMINATION_DETECTION);
		return ans;
	}

}
