package simulation.metric;

import java.io.Serializable;

public class Metric implements Serializable {
	private static final long serialVersionUID = 1425145148424086346L;

	public static final String moins = "-";
	public static final String plus = "+";
	public static final String min = "min";
	public static final String max = "max";

	public double value;
	public String name;
	public String operator = plus; // default operator

	public Metric(String name, double value) {
		this.name = name;
		this.value = value;
	}

	public Metric(String name, double value, String operator) {
		this.name = name;
		this.value = value;
		this.operator = operator;
	}

	public Metric(String name) {
		this(name, 0L);
	}

	public String toString() {
		return name + ":" + this.value + "(" + this.operator + ")";
	}

}
