package simulation.metric;

import java.util.ArrayList;
import java.util.HashSet;

import kernel.AbstractAgent;
import kernel.AbstractMaster;
import kernel.AgentObserver;
import kernel.com.Message;
import kernel.events.AgentEvent;
import kernel.events.AgentFinishedEvent;
import kernel.events.AgentStateListener;
import util.Commands;

public class StatisticsAgentManager extends AgentStateListener {

	public StatisticsAgentManager(AbstractAgent agent) {
		super(agent);
	}

	@Override
	public void handleAgentEvent(AgentEvent agentEvent) {
		if (agentEvent instanceof AgentFinishedEvent) {
			ArrayList<Metric> statistics = this.getSatatistics();
			Message msg = new Message(Commands.STATISTICS);
			msg.addContents(Commands.STATISTICS, statistics);
			msg.setReceiverId(AbstractMaster.MasterVarId);
			this.myAgent.sendMessage(msg);
		}
	}

	private ArrayList<Metric> getSatatistics() {
		ArrayList<Metric> statistics = new ArrayList<Metric>();
		HashSet<AgentObserver> observers = this.myAgent.getAgentObservers();
		for (AgentObserver o : observers) {
			if (o instanceof MetricListener) {
				statistics.addAll(((MetricListener) o).getEndStatistics());
			}
		}
		statistics.addAll(this.myAgent.getAuxiliaryStatistics());
		return statistics;
	}
}
