package simulation.model.expressions;

import java.util.List;

public class AbsIntExpression implements IntegerExpression {

	IntegerExpression exp = null;

	public AbsIntExpression(IntegerExpression exp) {
		this.exp = exp;
	}

	public IntegerExpression getExpression() {
		return exp;

	}

	@Override
	public Integer evaluate() {
		return Math.abs(this.exp.evaluate());
	}

	@Override
	public boolean isReady() {
		return this.exp.isReady();
	}

	@Override
	public List<? extends VariableExpression> getVariableExpressions() {
		return exp.getVariableExpressions();
	}

	@Override
	public String getSymbol() {
		return "Abs:" + this.exp.getSymbol();
	}

	@Override
	public String getFunctionalExpression(int fromIndex) {
		return "abs(" + this.exp.getFunctionalExpression(fromIndex) + ")";
	}

	@Override
	public int getNbVariableExpression() {
		return this.exp.getNbVariableExpression();
	}

}
