package simulation.model.expressions;

public class AndExpression extends BinaryExpression implements BooleanExpression {

	public AndExpression(BooleanExpression left, BooleanExpression right) {
		super(left, right);
	}

	@Override
	public String getSymbol() {
		return "&&";
	}

	@Override
	public boolean isReady() {
		return this.fLeft.isReady() && this.fRight.isReady();
	}

	public Boolean evaluate() {
		Boolean lValue = null, rValue = null;
		lValue = (Boolean) getLeft().evaluate();
		rValue = (Boolean) getRight().evaluate();
		if (lValue != null && rValue == null)
			return lValue;
		if (lValue == null && rValue != null)
			return rValue;
		return (rValue && lValue);
	}

	public String getFunctionalExpression(int fromIndex) {
		return "and(" + super.getFunctionalExpression(fromIndex) + ")";
	}

}
