package simulation.model.expressions;

import java.util.ArrayList;
import java.util.List;

import kernel.Constraint;

public class ConstraintExpression implements BooleanExpression {

	Constraint constraint;

	public ConstraintExpression(Constraint constraint) {
		this.constraint = constraint;
	}

	@Override
	public List<VariableExpression> getVariableExpressions() {
		return new ArrayList<VariableExpression>();
	}

	@Override
	public boolean isReady() {
		return this.constraint.isCompletlyInstantiated();
	}

	@Override
	public Boolean evaluate() {
		return this.constraint.isSatisfied();
	}

	@Override
	public String getSymbol() {
		return "Constraint-Expression:" + this.constraint.getReference();
	}

	@Override
	public String getFunctionalExpression(int fromIndex) {
		throw new UnsupportedOperationException();
	}

	@Override
	public int getNbVariableExpression() {
		throw new UnsupportedOperationException();
	}

}
