package simulation.model.expressions;

public class DivideIntExpression extends BinaryExpression implements IntegerExpression {

	public DivideIntExpression(Expression left, Expression right) {
		super(left, right);
	}

	public Integer evaluate() {
		Integer lValue = (Integer) getLeft().evaluate();
		Integer rValue = (Integer) getRight().evaluate();
		return lValue.intValue() / rValue.intValue();
	}

	public String getSymbol() {
		return "/";
	}

	@Override
	public boolean isReady() {
		return this.fLeft.isReady() && this.fRight.isReady();
	}

	public String getFunctionalExpression(int fromIndex) {
		return "div(" + super.getFunctionalExpression(fromIndex) + ")";
	}

}
