package simulation.model.expressions;

import simulation.parser.PredicateTokens;

public class EqualIntExpression extends BinaryExpression implements BooleanExpression {

	public EqualIntExpression(IntegerExpression left, IntegerExpression right) {
		super(left, right);
	}

	public EqualIntExpression(IntegerExpression e, int cste) {
		this(e, new IntConstantExpression(cste));
	}

	@Override
	public String getSymbol() {
		return "=";
	}

	@Override
	public Boolean evaluate() {
		int lValue = (Integer) getLeft().evaluate();
		int rValue = (Integer) getRight().evaluate();
		return lValue == rValue;
	}

	public String getFunctionalExpression(int fromIndex) {
		return PredicateTokens.EQ + "(" + super.getFunctionalExpression(fromIndex) + ")";
	}

}
