package simulation.model.expressions;

import java.util.List;

public interface Expression {

	public abstract List<? extends VariableExpression> getVariableExpressions();

	/**
	 * Returns true when the expression can be evaluated
	 */
	public abstract boolean isReady();

	/**
	 * This method evaluates/computes the expression.
	 */
	public abstract Object evaluate();

	public abstract String getSymbol();

	public abstract String getFunctionalExpression(int fromIndex);

	public abstract int getNbVariableExpression();

}
