package simulation.model.expressions;

public class ExpressionFactory {

	// //////////////////////////////////////////////////////////////////////////////////////////////
	// /////////////////// Integer expressions
	// /////////////////////////////////////////////////////

	public static IntegerExpression plus(IntegerExpression intExp1, IntegerExpression intExp2) {
		return new PlusIntExpression(intExp1, intExp2);
	}

	public static Expression minus(IntegerExpression intExp1, int i) {
		return minus(intExp1, new IntConstantExpression(i));
	}

	public static IntegerExpression div(IntegerExpression intExp1, IntegerExpression intExp2) {
		return new DivideIntExpression(intExp1, intExp2);
	}

	public static IntegerExpression mod(IntegerExpression intExp1, IntegerExpression intExp2) {
		return new ModuloIntExpression(intExp1, intExp2);
	}

	public static IntegerExpression mult(IntegerExpression intExp1, IntegerExpression intExp2) {
		return new MultiplyIntExpression(intExp1, intExp2);
	}

	public static IntegerExpression neg(IntegerExpression intExp) {
		return new NegationIntExpression(intExp);
	}

	public static IntegerExpression pow(IntegerExpression intExp1, IntegerExpression intExp2) {
		return new PowerIntExpression(intExp1, intExp2);
	}

	public static IntegerExpression minus(IntegerExpression intExp1, IntegerExpression intExp2) {
		return new MinusIntExpression(intExp1, intExp2);
	}

	public static IntegerExpression abs(IntegerExpression intExp) {
		return new AbsIntExpression(intExp);
	}

	public static IntegerExpression max(IntegerExpression intExp1, IntegerExpression intExp2) {
		return new PlusIntExpression(intExp1, intExp2);
	}

	public static IntegerExpression min(IntegerExpression intExp1, IntegerExpression intExp2) {
		return new PlusIntExpression(intExp1, intExp2);
	}

	// ////////////////////////////////////////////////////////////////////////////////////////////////////
	// //////////////////////////// /////////////////////////////////////////

	public static IntegerExpression ifThenElse(BooleanExpression cond, IntegerExpression intExp1, IntegerExpression intExp2) {
		return new IfThanElseIntExpression(cond, intExp1, intExp2);
	}
}
