package simulation.model.expressions;

import simulation.parser.PredicateTokens;

public class GreateThanExpression extends BinaryExpression implements BooleanExpression {

	public GreateThanExpression(Expression left, Expression right) {
		super(left, right);
	}

	public GreateThanExpression(IntegerExpression e, int cste) {
		this(e, new IntConstantExpression(cste));
	}

	@Override
	public Boolean evaluate() {
		int lValue = (Integer) getLeft().evaluate();
		int rValue = (Integer) getRight().evaluate();
		return lValue > rValue;
	}

	public String getFunctionalExpression(int fromIndex) {
		return PredicateTokens.GT + "(" + super.getFunctionalExpression(fromIndex) + ")";
	}

	@Override
	public String getSymbol() {
		return ">";
	}

}
