package simulation.model.expressions;

import simulation.parser.PredicateTokens;

public class GreaterOrEqualExpression extends BinaryExpression implements BooleanExpression {

	public GreaterOrEqualExpression(Expression left, Expression right) {
		super(left, right);
	}

	public GreaterOrEqualExpression(IntegerExpression e, int cste) {
		this(e, new IntConstantExpression(cste));
	}

	@Override
	public Boolean evaluate() {
		int lValue = (Integer) getLeft().evaluate();
		int rValue = (Integer) getRight().evaluate();
		return lValue >= rValue;
	}

	public String getFunctionalExpression(int fromIndex) {
		return PredicateTokens.GE + "(" + super.getFunctionalExpression(fromIndex) + ")";
	}

	@Override
	public String getSymbol() {
		return ">=";
	}

}
