package simulation.model.expressions;

public class IfThanElseIntExpression extends BinaryExpression implements IntegerExpression {

	BooleanExpression condition;

	public IfThanElseIntExpression(BooleanExpression cond, IntegerExpression left, IntegerExpression right) {
		super(left, right);
		this.condition = cond;
	}

	@Override
	public String getSymbol() {
		return "ifThenElse";
	}

	@Override
	public Integer evaluate() {
		if (this.condition.evaluate())
			return (Integer) this.fLeft.evaluate();
		else
			return (Integer) this.fRight.evaluate();
	}

	@Override
	public boolean isReady() {
		return super.isReady() && condition.isReady();
	}

}
