package simulation.model.expressions;

import java.util.ArrayList;
import java.util.List;

import kernel.vars.integer.IntVariable;

public class IntVariableExpression extends VariableExpression implements IntegerExpression {

	Integer tempVal = null;

	public IntVariableExpression(IntVariable var) {
		super(var);
	}

	public void removeTemporaryValue() {
		this.tempVal = null;
	}

	@Override
	public void setTemporaryValue(Object val) {
		this.tempVal = (Integer) val;
	}

	@Override
	public Integer evaluate() {
		if (tempVal == null)
			return ((IntVariable) var).getValue();
		return tempVal;
	}

	@Override
	public boolean isReady() {
		return this.var.isInstantiated() || this.tempVal != null;
	}

	@Override
	public List<VariableExpression> getVariableExpressions() {
		List<VariableExpression> list = new ArrayList<VariableExpression>();
		list.add(this);
		return list;
	}

	@Override
	public String getSymbol() {
		return var.getVarIdentifier().toString();
	}

	@Override
	public String getFunctionalExpression(int fromIndex) {
		return "X" + fromIndex;
	}

	@Override
	public int getNbVariableExpression() {
		return 1;
	}

	public String toString() {
		return this.getSymbol();
	}

}
