package simulation.model.expressions;

import simulation.parser.PredicateTokens;

public class LessOrEqualIntExpression extends BinaryExpression implements BooleanExpression {

	public LessOrEqualIntExpression(IntegerExpression left, IntegerExpression right) {
		super(left, right);
	}

	public LessOrEqualIntExpression(IntegerExpression e, int cste) {
		this(e, new IntConstantExpression(cste));
	}

	@Override
	public Boolean evaluate() {
		int lValue = (Integer) getLeft().evaluate();
		int rValue = (Integer) getRight().evaluate();
		return lValue <= rValue;
	}

	public String getFunctionalExpression(int fromIndex) {
		return PredicateTokens.LE + "(" + super.getFunctionalExpression(fromIndex) + ")";
	}

	@Override
	public String getSymbol() {
		return ">=";
	}
}
