package simulation.model.expressions;

public class MinusIntExpression extends BinaryExpression implements IntegerExpression {

	public MinusIntExpression(IntegerExpression left, IntegerExpression right) {
		super(left, right);
	}

	public MinusIntExpression(IntegerExpression e, int cste) {
		this(e, new IntConstantExpression(cste));
	}

	public Integer evaluate() {
		Integer lValue = (Integer) getLeft().evaluate();
		Integer rValue = (Integer) getRight().evaluate();
		return lValue.intValue() - rValue.intValue();
	}

	public String getSymbol() {
		return "-";
	}

	@Override
	public boolean isReady() {
		return this.fLeft.isReady() && this.fRight.isReady();
	}

	public String getFunctionalExpression(int fromIndex) {
		return "sub(" + super.getFunctionalExpression(fromIndex) + ")";
	}
}
