package simulation.model.expressions;

public class ModuloIntExpression extends BinaryExpression implements IntegerExpression {

	public ModuloIntExpression(IntegerExpression left, IntegerExpression right) {
		super(left, right);
	}

	public Integer evaluate() {
		Integer lValue = (Integer) getLeft().evaluate();
		Integer rValue = (Integer) getRight().evaluate();
		return lValue.intValue() % rValue.intValue();
	}

	public String getSymbol() {
		return "%";
	}

	@Override
	public boolean isReady() {
		return this.fLeft.isReady() && this.fRight.isReady();
	}

	public String getFunctionalExpression(int fromIndex) {
		return "mod(" + super.getFunctionalExpression(fromIndex) + ")";
	}
}
