package simulation.model.expressions;

public class MultiplyIntExpression extends BinaryExpression implements IntegerExpression {

	public MultiplyIntExpression(IntegerExpression left, IntegerExpression right) {
		super(left, right);
	}

	public Integer evaluate() {
		Integer lValue = (Integer) getLeft().evaluate();
		Integer rValue = (Integer) getRight().evaluate();
		return lValue.intValue() * rValue.intValue();
	}

	public String getSymbol() {
		return "*";
	}

}
