package simulation.model.expressions;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public abstract class NaryExpression implements Expression {

	protected List<Expression> fExpressions;

	public NaryExpression() {}

	public NaryExpression(List<Expression> expressions) {
		super();
		setExpressions(expressions);
	}

	public List<Expression> getExpressions() {
		return fExpressions;
	}

	public void setExpressions(List<Expression> expressions) {
		fExpressions = expressions;
	}

	public abstract String getSymbol();

	@Override
	public List<VariableExpression> getVariableExpressions() {
		List<VariableExpression> all = new ArrayList<VariableExpression>();
		Iterator<Expression> it = fExpressions.iterator();
		while (it.hasNext()) {
			Expression e = (Expression) it.next();
			all.addAll(e.getVariableExpressions());
		}
		return all;
	}

	@Override
	public int getNbVariableExpression() {
		return this.getVariableExpressions().size();
	}

	public String toString() {
		StringBuffer out = new StringBuffer(getSymbol() + "(");
		Iterator<Expression> i = fExpressions.iterator();
		while (i.hasNext()) {
			Expression e = (Expression) i.next();
			out.append(e.toString());
			if (i.hasNext()) {
				out.append(", ");
			}
		}
		return out + ")";
	}
}
