package simulation.model.expressions;

import java.util.List;

public class NegationIntExpression implements IntegerExpression {

	IntegerExpression exp = null;

	public NegationIntExpression(IntegerExpression exp) {
		this.exp = exp;
	}

	@Override
	public Integer evaluate() {
		return -(this.exp.evaluate());
	}

	@Override
	public boolean isReady() {
		return this.exp.isReady();
	}

	@Override
	public List<? extends VariableExpression> getVariableExpressions() {
		return exp.getVariableExpressions();
	}

	@Override
	public String getSymbol() {
		return "Negation:" + exp.getSymbol();
	}

	@Override
	public String getFunctionalExpression(int fromIndex) {
		return "neg(X" + fromIndex + ")";
	}

	@Override
	public int getNbVariableExpression() {
		return this.exp.getNbVariableExpression();
	}

}
