package simulation.model.expressions;

public class NotEqualIntExpression extends BinaryExpression implements BooleanExpression {

	public NotEqualIntExpression(IntegerExpression left, IntegerExpression right) {
		super(left, right);
	}

	public NotEqualIntExpression(IntegerExpression e, int cste) {
		this(e, new IntConstantExpression(cste));
	}

	@Override
	public String getSymbol() {
		return "#";
	}

	@Override
	public boolean isReady() {
		return this.fLeft.isReady() && this.fRight.isReady();
	}

	@Override
	public Boolean evaluate() {
		int lValue = (Integer) getLeft().evaluate();
		int rValue = (Integer) getRight().evaluate();
		return lValue != rValue;
	}

	public String getFunctionalExpression(int fromIndex) {
		return "neq(" + super.getFunctionalExpression(fromIndex) + ")";
	}
}
