package simulation.model.expressions;

import java.util.List;

public class NotExpression implements BooleanExpression {

	BooleanExpression exp;

	public NotExpression(BooleanExpression boolExpr) {
		this.exp = boolExpr;
	}

	@Override
	public Boolean evaluate() {
		return !exp.evaluate();
	}

	@Override
	public String getSymbol() {
		return "!";
	}

	@Override
	public List<VariableExpression> getVariableExpressions() {
		return this.getVariableExpressions();
	}

	@Override
	public boolean isReady() {
		return this.exp.isReady();
	}

	@Override
	public String getFunctionalExpression(int fromIndex) {
		return "not(" + this.exp.getFunctionalExpression(fromIndex) + ")";
	}

	@Override
	public int getNbVariableExpression() {
		return this.exp.getNbVariableExpression();
	}

}
