package simulation.model.expressions;

public class OrExpression extends BinaryExpression implements BooleanExpression {

	public OrExpression(Expression left, Expression right) {
		super(left, right);
	}

	@Override
	public String getSymbol() {
		return "||";
	}

	@Override
	public boolean isReady() {
		return this.fLeft.isReady() || this.fRight.isReady();
	}

	@Override
	public Boolean evaluate() {
		Boolean lValue = null, rValue = null;
		lValue = (Boolean) getLeft().evaluate();
		rValue = (Boolean) getRight().evaluate();
		if (lValue != null && rValue == null)
			return lValue;
		if (lValue == null && rValue != null)
			return rValue;
		return (rValue || lValue);
	}

	public String getFunctionalExpression(int fromIndex) {
		return "or(" + super.getFunctionalExpression(fromIndex) + ")";
	}
}
