package simulation.model.expressions;

public class PlusIntExpression extends BinaryExpression implements IntegerExpression {

	public PlusIntExpression(IntegerExpression left, IntegerExpression right) {
		super(left, right);
	}

	public PlusIntExpression(IntegerExpression e, int cste) {
		this(e, new IntConstantExpression(cste));
	}

	public String getSymbol() {
		return "+";
	}

	@Override
	public boolean isReady() {
		return this.fLeft.isReady() && this.fRight.isReady();
	}

	@Override
	public Integer evaluate() {
		Integer lValue = (Integer) getLeft().evaluate();
		Integer rValue = (Integer) getRight().evaluate();
		return lValue.intValue() + rValue.intValue();
	}

	public String getFunctionalExpression(int fromIndex) {
		return "add(" + super.getFunctionalExpression(fromIndex) + ")";
	}
}
