package simulation.model.expressions;

public class PowerIntExpression extends BinaryExpression implements IntegerExpression {

	public PowerIntExpression(Expression left, Expression right) {
		super(left, right);
	}

	public Integer evaluate() {
		Integer lValue = (Integer) getLeft().evaluate();
		Integer rValue = (Integer) getRight().evaluate();
		return (int) Math.pow(lValue.intValue(), rValue.intValue());
	}

	public String getSymbol() {
		return "pow";
	}

	@Override
	public boolean isReady() {
		return this.fLeft.isReady() && this.fRight.isReady();
	}

	public String getFunctionalExpression(int fromIndex) {
		return "pow(" + super.getFunctionalExpression(fromIndex) + ")";
	}
}
