package simulation.model.expressions;

import java.util.ArrayList;
import java.util.List;

public class SumIntExpression extends NaryExpression {

	public SumIntExpression(List<IntegerExpression> expressions) {
		super();
		this.fExpressions = new ArrayList<Expression>();
		for (Expression e : expressions) {
			this.fExpressions.add(e);
		}
	}

	@Override
	public String getSymbol() {
		return "sum";
	}

	@Override
	public Object evaluate() {
		Object[] values = new Object[fExpressions.size()];
		int[] ready = new int[fExpressions.size()];
		// computes the values
		for (int i = 0 ; i < fExpressions.size() ; i++) {
			if (((Expression) fExpressions.get(i)).isReady()) {
				ready[i] = 1;
				values[i] = ((Expression) fExpressions.get(i)).evaluate();
			} else
				ready[i] = 0;
		}
		// compute sum
		Integer sum = new Integer(0);
		for (int i = 0 ; i < fExpressions.size() ; i++) {
			if (ready[i] == 1)
				sum += ((IntegerExpression) fExpressions.get(i)).evaluate();
		}
		return sum;
	}

	@Override
	public boolean isReady() {
		for (int i = 0 ; i < fExpressions.size() ; i++) {
			if (((Expression) fExpressions.get(i)).isReady())
				return true;
		}
		return false;
	}

	@Override
	public String getFunctionalExpression(int fromIndex) {
		throw new Error("TODO");
	}

}
