package simulation.parser;

import kernel.AbstractAgent;
import kernel.vars.integer.IntExternalVar;

public class PAllDifferent extends PGlobalConstraint {

	public PAllDifferent(String name, PVariable[] scope) {
		super(name, scope);
	}

	public long computeCostOf(int[] tuple) {
		for(int i = 0 ; i < tuple.length - 1 ; i++)
			for(int j = i + 1 ; j < tuple.length ; j++)
				if (tuple[i] == tuple[j])
					return 1;
		return 0;
	}

	public String toString() {
		String s = super.toString() + " reference=\"global:allDifferent\">\n";
		s += "\t\t\t<parameters>[ ";
		for(int i = 0 ; i < super.scope.length ; i++)
			s += super.scope[i].getName() + " ";
		s += "]</parameters>\n";
		s += "\t\t</constraint>";
		return s;
	}

	@Override
	public void makeConstraint() {
		//FIXME
		//throw new UnsupportedOperationException("Not yet implemeneted");
		int length = this.scope.length;
		for(int i = 0 ; i <length -1 ; i++) {
			AbstractAgent Ai = this.scope[i].getDisChocoAgent();
			PVariable var_i = this.scope[i];
			for(int j = i+1 ; j <length ; j++) {
				IntExternalVar varj = Ai.makeExternalVar(this.scope[j]);
				Ai.neqY(varj);
				AbstractAgent Aj = this.scope[j].getDisChocoAgent();
				IntExternalVar vari = Aj.makeExternalVar(var_i);
				Aj.neqY(vari);
			}
		}
	}
}
