package simulation.parser;

import kernel.AbstractAgent;
import kernel.VarIdentifier;
import kernel.vars.integer.IntExternalVar;
import kernel.vars.integer.IntVariable;
import simple.SimpleAgent;

public class PVariable implements Comparable<Object> {
	
	private PAgent agent;
	private String name;
	private int id;
	private String description;
	private PDomain domain;

	private AbstractAgent disChocoAgent = null;

	public PAgent getAgent() {
		return this.agent;
	}

	public void setAgent(PAgent agent) {
		this.agent = agent;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return this.description;
	}

	public int getId() {
		return this.id;
	}

	public int getAgentId() {
		return this.agent.getId();
	}

	public PDomain getDomain() {
		return domain;
	}

	public void setDomain(PDomain dom) {
		domain = dom;
	}

	/**
	 * 
	 * @param agent
	 * @param name
	 * @param id
	 * @param description
	 * @param domain
	 */
	public PVariable(PAgent agent, String name, int id, String description, PDomain domain) {
		this.agent = agent;
		this.name = name;
		this.id = id;
		this.description = description;
		this.domain = domain;

	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("<").append(InstanceTokens.VARIABLE).append(" ");// "<variable "
		sb.append(InstanceTokens.AGENT).append("=\"").append(this.agent.getName()).append("\" "); // agent=this.agent.getName()
		sb.append(InstanceTokens.NAME).append("=\"").append(this.name).append("\" "); // name=this.name 
		sb.append(InstanceTokens.ID).append("=\"").append(this.id).append("\" "); // id=this.id
		sb.append(InstanceTokens.DESCRIPTION).append("=\"").append(this.description).append("\""); // description=this.description
		sb.append("/>");
		return sb.toString();
	}

	public int compareTo(Object o) {
		PVariable v = (PVariable) o;
		return this.id - v.id;
	}
	
	public void setId(int i) {
		this.id = i;
	}

	public IntVariable makeIntVariable(SimpleAgent agent) {
		Integer values[] = this.getDomain().getValues();
		VarIdentifier varId = this.getVarIdentifier();
		return agent.makeVariable(this.name, varId, values);
	}

	public IntExternalVar makeExternalVar(SimpleAgent agent) {
		Integer values[] = this.getDomain().getValues();
		return agent.makeExternalVar(this.name, this.getAgentId(), this.id, values);
	}

	/**
	 * @return
	 */
	public VarIdentifier getVarIdentifier() {
		return new VarIdentifier(getAgentId(), getId());
	}

	
	public void setDisChocoAgent(AbstractAgent disChocoAgent) {
		this.disChocoAgent = disChocoAgent;
	}

	public AbstractAgent getDisChocoAgent() {
		return disChocoAgent;
	}

}
