/*
DisChoco: Distributed Constraint Reasoning Solver 
Copyright (C) 2007-2013 Redouane Ezzahir & Mohamed Wahbi 

DisChoco is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

DisChoco is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

To contact the authors: <http://dischoco.sourceforge.net/>
*/ 
package util;

import java.util.Arrays;
import java.util.Comparator;

/**
 * @version dischoco 2.5.3<br/>
 * kernel.constraints.integer.soft.ArrayIndexComparator.java
 * @author Mohamed Wahbi
 */
public class ArrayIndexComparator<T extends Comparable<T>> implements Comparator<Integer> {

	private final T[] array;

	public ArrayIndexComparator(T[] array) {
		this.array = array;
	}

	public Integer[] createIndexArray() {
		Integer[] indexes = new Integer[array.length];
		for(int i = 0 ; i < array.length ; i++) {
			indexes[i] = i;
		}
		return indexes;
	}

	@Override
	public int compare(Integer index1, Integer index2) {
		return array[index1].compareTo(array[index2]);
	}

	public static void main(String[] args) {
		String[] countries = {"France", "Spain", "France", "France", "Italy", "Spain", "Spain", "Italy"};
		ArrayIndexComparator<String> comparator = new ArrayIndexComparator<String>(countries);
		Integer[] indexes = comparator.createIndexArray();
		System.out.println(Arrays.toString(indexes));
		System.out.println(Arrays.toString(countries));
		Arrays.sort(indexes, comparator);
		System.out.println(Arrays.toString(indexes));
		System.out.println(Arrays.toString(countries));
	}
	
}