/*
DisChoco: Distributed Constraint Reasoning Solver 
Copyright (C) 2007-2013 Redouane Ezzahir & Mohamed Wahbi 

DisChoco is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

DisChoco is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

To contact the authors: <http://dischoco.sourceforge.net/>
*/ 
package util;

public final class Commands {
	public static final String DisChoco_TITLE = "DisChoco: Distributed Constraint Reasoning Solver"; // DisChocoDescription
	public static final String copyrightNotice = 
			"DisChoco Copyright (C) 2007-2013 Redouane Ezzahir & Mohamed Wahbi.\n" +
			"This program comes with ABSOLUTELY NO WARRANTY.\n"+
			"This is free software, and you are welcome to redistribute it.\n"+
			"under certain conditions.\n";

	public static final String GNUPLOT = "/usr/local/bin/gnuplot";
	public static final String epstopdf = "/usr/local/bin/epstopdf";
	public static final String DOT = "/usr/local/bin/dot";
	public static final String BZIP2 = "bzip2";
	
	public static final String MASTER = "Master";
	public static final String INITIALIZER = "initializer";
	public static final String TERMINATION_DETECTION = "termination";
	public static final String DENSITY = "density";
	public static final String TIGHTNESS = "tightness";
	public static final String INTER_AGENTS_DENSITY = "interAgentsDensity";
	public static final String CONNECTION_DENSITY = "connectionDensity";
	public static final String P_1 = "p1";
	public static final String P_2 = "p2";
	
	public static final String DENSITY_OF_GRAPH = "Graph Density";
	public static final String CONSTRAINTS_TIGHTNESS = "Constraints Tightness";
	public static final String MIN_P2 = "minP2";
	public static final String MAX_P2 = "maxP2";
	public static final String STEP_P2 = "stepP2";
	public static final String GuiPresentation = "GuiPresentation";
	
	public static final String FROM = "From";
	public static final String TO = "To";
	public static final String STEP = "Step";

	public static final String SYSTEM = "system";
	public static final String INIT = "init";
	public static final String PROB_DEF = "pb_def";

	public static final String GET_CONNECTION = "GET_CONNECTION";
	public static final String CONNECTION_OK = "CONNECTION_OK";
	public static final String GET_START_INIT = "GET_START_INIT";
	public static final String GET_START_DS = "GET_START_DISTRIBUTED_SEARCH";
	public static final String START_INIT_OK = "START_INIT_OK";
	public static final String START_DS_OK = "START_DISTRIBUTED_SEARCH_OK";
	public static final String SIMULATION_USE = "SIMULATION_USE";
	public static final String REALISTIC_USE = "REALISTIC_USE";
	public static final String END_INIT_AND_START_DS = "End_Init_And_Start_DS";
	public static final String INITIAL_END_AGENT = "Initial_End_Agent";

	public static final String SenderID = "from";
	public static final String ReceiverID = "to";
	public static final String MSG_TYPE = "type";
	public static final String CONTENTS = "contents";
	public static final String ID = "id";
	//public static final String VARID = "varId";
	public static final String LTC = "ltc";
	public static final String AgentIDs = "agIds";
	public static final String TERMINATE = "TERMINATE";
	public static final String ERROR = "ERROR";
	public static final String FAILURE = "FAILURE";
	public static final String SUCCESS = "SUCCESS";
	public static final String ACCEPTED = "ACCEPTED";

	public static final String OK = "OK";
	public static final String INFO = "INFO";

	public static final String NOGOOD = "NOGOOD";
	public static final String ADDLINK = "ADL";
	public static final String PROPAGATION = "propagation";
	public static final String VALUE = "VALUE";
	public static final String COST = "COST";
	public static final String CPA = "CPA";
	public static final String SOLUTION_COST = "Solution_Cost";
	public static final String FB_CPA = "FB_CPA";
	public static final String ESTIMATE = "ESTIMATE";
	public static final String SOLUTION = "solution";
	public static final String HANDLER_TYPE = "handler";
	public static final String RHS = "rhs";
	public static final String LHS = "lhs";
	public static final String ORDER = "ORDER";
	public static final String REORDER = "REORDER";
	public static final Object INVERSE_ORDER = "Inv_Order";
	public static final String FC = "FC"; // "FORWARD_CHECKING";
	public static final String CONTEXT = "CONTEXT";
	public static final String FC_CTX = "FC_CTX"; // "FORWARD_CHECKING_CONTEXT";
	public static final String FC_NG = "FC_NG"; // "FORWARD_CHECKING_NOGOOD";
	public static final String BACKTRACK = "BACK";
	public static final String LOCALSEARCH = "LSearch";
	public static final String AO = "AgentOrdering";
	public static final String AGENT_DESCRIPTION = "Agent_Descrirption";

	public static final String COMPLEXITY = "Complexity";
	public static final String DomainSize = "domainSize";
	public static final String NB_CONSTRAINTS = "nbConstraints";

	// ************************ DisFC ****************************
	public static final String TKC = "TKC"; // constraint model : Totally known constraint
	public static final String PKC = "PKC"; // constraint model : Partially known constraint
	public static final String TOTALLY_KNOWN_CONSTRAINT = "Totally Known Constraint";
	public static final String PARTIALLY_KNOWN_CONSTRAINT = "Partially Known Constraint";
	public static final String SUCCEFULLY = "Problems are generated succefully";
	
	public static final String BROWSE = "Browse";
	public static final String GENERATE = "Generate";
	public static final String CONSTRAINT_MODEL = "Constraint Model";

	public static final String FC_CPA = "fc_cpa";

	public static final String SIMPLE = "Simple";

	public static final String DELETE = "delete";
	public static final String SEQUENCE = "sequence";
	public static final String TIMESTAMP = "TimeStamp";

	public static final String THRESHOLD = "THRESHOLD";
	public static final String NEIGHBORS = "neighbors";
	public static final String NCSteps = "NCSteps";

	public static final String NCCCs = "ncccs";
	public static final String CCs = "CCs";
	public static final String GNCCCs = "gncccs";

	public static final String STATISTICS = "Statistics";
	public static final String MSGs = "msg";
	public static final String nbMsgSend = "nbMsgSend";
	public static final String nbMsgRcvd = "nbMsgRcvd";
	public static final String NOT_OK = "not_ok";

	// ************************ Communications ****************************
	public static final String RandomTKC = "RandomTKC";
	public static final String RandomPKC = "RandomPKC";
	public static final String ComplexRandomTKC = "ComplexRandomTKC";
	public static final String ComplexRandomPKC = "ComplexRandomPKC";
	public static final String Random = "Random";
	public static final String RandomDisCSP = "RandomDisCSP";
	public static final String RandomDCOP = "RandomDCOP";
	public static final String RandomMaxDisCSP = "RandomMax-DisCSP";
	public static final String DisCSP = "DisCSP";
	public static final String MaxDisCSP = "Max-DisCSP";
	public static final String ComplexDisCSP = "ComplexDisCSP";
	public static final String DCSP = "DCSP";
	public static final String DCOP = "DCOP";
	public static final String GraphColoring = "Graph Coloring";
	public static final String GC = "GC";
	public static final String COMPLEX = "Complex";
	public static final String NQueen = "NQueen";
	public static final String SOLVABLE = "solvability"; // satisfiability 
//	public static final String ComplexRandomTKC = "Complex Random TKC";

	public static final String SensorNetworking = "Sensor Networking";
	public static final String SensorNetworks = "SensorNetworks";
	public static final String GSensorDCSP = "GSensorDCSP";
	public static final String SensorDCSP = "SensorDCSP";
	public static final String MeetingScheduling = "MeetingScheduling";
	public static final String RMSP = "RandomMSP";
	public static final String MSP = "MSP";
	public static final String DIMES = "DiMES";
	public static final String DIMES_LONG = "Distributed Multi-Event Scheduling";

	public static final String URDisCSP = "Random DisCSP";
	public static final String URDisCSP_LONG = "Uniform Random Binary DisCSP";
	public static final String DMSP = "Distributed Meeting Scheduling";
	public static final String DSNP = "Distributed Sensor Networking";
	public static final String URGColoring = "Random Graph Coloring";
	public static final String SoftGraphColoring = "Soft Graph Coloring";
	public static final String URSGCP = "SGCP";
	public static final String URSGCP_LONG = "Uniform Random Soft Graph Coloring";
	public static final String DisNQueen = "Distributed N-Queen";
	public static final String URDCOP = "Random DCOP";
	public static final String URDCOP_LONG = "Uniform Random Binary DCOP";
	public static final String URMaxDisCSP = "Random Max-DisCSP";
	public static final String URMaxDisCSP_LONG = "Uniform Random Binary Max-DisCSP";
	public static final String URComplexDisCSP = "Random Complex DisCSP";
	public static final String URComplexDisCSP_LONG = "Uniform Random Binary DisCSP with Complex Agent";
	public static final String URComplexGColoring = "Complex Graph Coloring";
	public static final String URComplexDCOP = "Random Complex DCOP";
	public static final String URComplexDCOP_LONG = "Uniform Random Binary DCOP with Complex Agent";

	public static final String Experiments = "experiments";
	public static final String Communications = "communications";
	public static final String nbCommunications = "nbCommunications";
	public static final String Communication = "communication";
	public static final String Algorithms = "algorithms";
	public static final String nbAlgorithms = "nbAlgorithms";
	public static final String Algorithm = "algorithm";
	public static final String Protocol = "protocol";
	
	public static final String STATE = "STATE";
	public static final String QUIESCENCE = "Quiescence";
	public static final String ChangeOrder = "ChangeOrder";
	public static final String IMPROVE = "improve";
	public static final String CYCLE = "Cycle";
	public static final String END_STATE = "END_STATE";
	public static final String URGENT = "URGENT";
	public static final String BROADCAST_SYSTEM_MSG = "BROADCAST_SYSTEM_MSG";
	public static final String AGENT_COMPLEXITY = "AGENT_COMPLEXITY";
	public static final String CC_CURRENT_CYCLE = "CCs_Curent_Cycle";

	public static final String LexicoAO = "LexicoAO";
	public static final String MinDomOverDegAO = "MinDomOverDegAO";
	public static final String RandomAO = "RandomAO";
	public static final String TreeAO = "TreeAO";
	public static final String MaxDegPlusMinDomAO = "MaxDegPlusMinDomAO";

	public static final String Results = "Results";
	public static final String FAST_COM = "Fast_Communication";
	public static final String SLOW_COM = "Slow_Communication";
	public static final String MEDIUM_COM = "Medium_Communication";
	public static final String[] communicationTypes = {FAST_COM, SLOW_COM, MEDIUM_COM};
//	public static final String type = "type";
	public static final String MinURC = "MinURC";
	public static final String MaxURC = "MaxURC";
	public static final String channelType = "channelType";
	public static final String NbRun = "NbRun";
	public static final String MaxNCCCs = "MaxNCCCs";
	public static final String FIFO = "FIFO";
	public static final String NON_FIFO = "NON_FIFO";
	public static final String[] channelsTypes = {FIFO, NON_FIFO};

	public static final String KEY = "key";
	public static final String OPERATOR = "Operator";
//	public static final String MAX = "max";
//	public static final String MIN = "min";
	public static final String CBR = "CBR";
	public static final String METRIC = "metric";
	public static final String NCCPUTime = "NCCPUTime(ms)";
	public static final String p2 = "P2";
	public static final String MsgStatistics = "MSG_STATISTIC";
	public static final String density = "desity";
	public static final String GRAPH = "Graph";
	public static final String TREE = "Tree";
	public static final String NCPairValue = "NCPairValue";

	public static final String Stampe = "stampe";
	public static final String Generator = "generator";
	public static final String Generators = "Generators";
	public static final String LINK = "link";
	public static final String OtherStatistics = "OtherStatistics";
	public static final String AUXILIARY_STATISTICS = "AuxStatistics";
//	public static final String plus = "+";

	// ================================================================================
	public static final String nbObsoleteNogood = "nbObsoleteNogood";
	public static final String ObsoleteOk = "ObsoleteOk";
	public static final String nbAssignments = "nbAssignments";

	public static final String COUNTER = "ctr";
	public static final String WEIGHT = "Weight";
	public static final String MSGsSIZE = "MsgsSize";
	public static final String MaxMSGsSIZE = "MaxMsgsSize";
	public static final String Control = "Control";
	
	
	public static final String MAX = "max";
	public static final String MIN = "min";
	public static final String CPU = "CPU(s)";
	public static final String Time = "time(s)";
	public static final String comulatedCpuTime = "comulatedCpuTime";
	public static final String Configuration = "configuration";
	public static final String LB = "LB";
	public static final String UB = "UB";
	public static final String MINIMUM_COST = "Minimum Cost";
	public static final String MAXIMUM_COST = "Maximum Cost";
	public static final String FRUCHTERMAN_REINGOLD = "Fruchterman-Reingold";
	public static final String KAMADAKAWAI = "KamadaKawai";

	
	// ================================================================================ GUI Commands
	
	public static final String NumberOfInstances = "Number of Instances";  
	public static final String NumberOfMeetings = "Number of Meetings";  
	public static final String DurationOfMeetings = "Duration of Meetings";
	public static final String NumberOfAgents = "Number of Agents";
	public static final String NumberOfConstraints = "Number of Constraints";
	public static final String NumberOfTuples = "Number of Tuples";
	public static final String SizeOfDomain = "Domain Size";
	public static final String NumberOfMeetingsPerAgent = "Number of Meetings per Agent";  
	public static final String NumberOfAgentPerMeetings = "Number of Agents per Meeting";  
	public static final String DisponibilityOfAgents = "Disponibility of Agents";  
	public static final String MINIMUM = "Minimum";  
	public static final String MAXIMUM = "Maximum";  
	public static final String NumberOfHours = "Number of Hours";  
	public static final String NumberOfDays = "Number of Days";  
	public static final String NumberOfSensors = "Number of Sensors";  
	public static final String NumberOfTargets = "Number of Targets";  
	public static final String NumberOfXAxis = "Number of x-axis";  
	public static final String NumberOfYAxis = "Number of y-axis";  
	public static final String NumberOfColors = "Number of Colors";
	public static final String GridSize = "GridSize";
	
	public static final String NB_SENSORS = "nbSensors";  
	public static final String NB_TARGETS = "nbTargets";
	public static final String Sensor = "Sensor";
	public static final String Sensors = "Sensors";
	public static final String Target = "Target"; 
	public static final String Targets = "Targets";  
	public static final String P_V = "Pv";
	public static final String P_C = "Pc";
	public static final String MIN_PV = "MinPv";
	public static final String MAX_PV = "MaxPv";
	public static final String STEP_PV = "StepPv";
	public static final String KC = "Kc";
	public static final String minKC = "minKc";
	public static final String maxKC = "maxKc";
	public static final String stepKC = "stepKc";
	public static final String KV = "Kv";
	public static final String minKV = "minKv";
	public static final String maxKV = "maxKv";
	public static final String stepKV = "stepKv";
	public static final String X_axis = "x_axis";
	public static final String Y_axis = "y_axis";
	
	public static final String GRID = "Grid"; // grid
	public static final String REAL = "Real"; // real 
	public static final String NB_MEETINGS = "nbMeetings";
	public static final String MEETINGS = "meetings";
	public static final String MEETING = "meeting";
	public static final String MEETINGS_DURATION = "meetingsDuration"; 
	public static final String NB_MEETINGS_PER_AGENT = "nbMeetingsPerAgent";
	public static final String NB_DAYS = "nbDays";
	public static final String NB_HOURS = "nbHours";
	public static final String DISPONIBILITY = "disponibility";
	public static final String DIRECTORY = "directory";
	public static final String SUBDIRECTORY = "subDirectory";

	public static final String MIN_MEETING_PER_AGENTS = "minMeetingPerAgents";
	public static final String MAX_MEETING_PER_AGENTS = "maxMeetingPerAgents";
	public static final String STEP_MEETING_PER_AGENTS = "stepMeetingPerAgents";

	public static final String NB_AGENTS_PER_MEETING = "nbAgentsPerMeeting";
	public static final String MIN_AGENTS_PER_MEETING = "minAgentsPerMeeting";
	public static final String MAX_AGENTS_PER_MEETING = "maxAgentsPerMeeting";
	public static final String STEP_AGENTS_PER_MEETING = "stepAgentsPerMeeting";

	public static final String MIN_GRID_SIZE = "minGridSize";
	public static final String MAX_GRID_SIZE = "maxGridSize";
	public static final String STEP_GRID_SIZE = "stepGridSize";
	public static final String SizeOfGrid = "Grid Size";
	
}
